function _typeof(o) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (o) { return typeof o; } : function (o) { return o && "function" == typeof Symbol && o.constructor === Symbol && o !== Symbol.prototype ? "symbol" : typeof o; }, _typeof(o); }
function _slicedToArray(r, e) { return _arrayWithHoles(r) || _iterableToArrayLimit(r, e) || _unsupportedIterableToArray(r, e) || _nonIterableRest(); }
function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _unsupportedIterableToArray(r, a) { if (r) { if ("string" == typeof r) return _arrayLikeToArray(r, a); var t = {}.toString.call(r).slice(8, -1); return "Object" === t && r.constructor && (t = r.constructor.name), "Map" === t || "Set" === t ? Array.from(r) : "Arguments" === t || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(t) ? _arrayLikeToArray(r, a) : void 0; } }
function _arrayLikeToArray(r, a) { (null == a || a > r.length) && (a = r.length); for (var e = 0, n = Array(a); e < a; e++) n[e] = r[e]; return n; }
function _iterableToArrayLimit(r, l) { var t = null == r ? null : "undefined" != typeof Symbol && r[Symbol.iterator] || r["@@iterator"]; if (null != t) { var e, n, i, u, a = [], f = !0, o = !1; try { if (i = (t = t.call(r)).next, 0 === l) { if (Object(t) !== t) return; f = !1; } else for (; !(f = (e = i.call(t)).done) && (a.push(e.value), a.length !== l); f = !0); } catch (r) { o = !0, n = r; } finally { try { if (!f && null != t["return"] && (u = t["return"](), Object(u) !== u)) return; } finally { if (o) throw n; } } return a; } }
function _arrayWithHoles(r) { if (Array.isArray(r)) return r; }
function _defineProperty(e, r, t) { return (r = _toPropertyKey(r)) in e ? Object.defineProperty(e, r, { value: t, enumerable: !0, configurable: !0, writable: !0 }) : e[r] = t, e; }
function _toPropertyKey(t) { var i = _toPrimitive(t, "string"); return "symbol" == _typeof(i) ? i : i + ""; }
function _toPrimitive(t, r) { if ("object" != _typeof(t) || !t) return t; var e = t[Symbol.toPrimitive]; if (void 0 !== e) { var i = e.call(t, r || "default"); if ("object" != _typeof(i)) return i; throw new TypeError("@@toPrimitive must return a primitive value."); } return ("string" === r ? String : Number)(t); }
import React from "react";
import { Collapse, List } from "antd";
import { getDisplayName } from "../shared/utils/viewerChannelSettings";
import ChannelsWidgetRow from "./ChannelsWidgetRow";
import SharedCheckBox from "./shared/SharedCheckBox";
import { connectToViewerState } from "./ViewerStateProvider";
var ChannelsWidget = function ChannelsWidget(props) {
  var channelGroupedByType = props.channelGroupedByType,
    channelSettings = props.channelSettings,
    channelDataChannels = props.channelDataChannels,
    filterFunc = props.filterFunc,
    viewerChannelSettings = props.viewerChannelSettings;
  var createCheckboxHandler = function createCheckboxHandler(key, value) {
    return function (channelArray) {
      props.changeChannelSetting(channelArray, _defineProperty({}, key, value));
    };
  };
  var showVolumes = createCheckboxHandler("volumeEnabled", true);
  var showSurfaces = createCheckboxHandler("isosurfaceEnabled", true);
  var hideVolumes = createCheckboxHandler("volumeEnabled", false);
  var hideSurfaces = createCheckboxHandler("isosurfaceEnabled", false);
  var renderVisibilityControls = function renderVisibilityControls(channelArray) {
    var volChecked = [];
    var isoChecked = [];
    channelArray.forEach(function (channelIndex) {
      var channelSetting = channelSettings[channelIndex];
      if (!channelSetting) return;
      if (channelSetting.volumeEnabled) {
        volChecked.push(channelIndex);
      }
      if (channelSetting.isosurfaceEnabled) {
        isoChecked.push(channelIndex);
      }
    });
    return /*#__PURE__*/React.createElement(React.Fragment, null, /*#__PURE__*/React.createElement(SharedCheckBox, {
      allOptions: channelArray,
      checkedList: volChecked,
      onChecked: showVolumes,
      onUnchecked: hideVolumes
    }, "All Vol"), /*#__PURE__*/React.createElement(SharedCheckBox, {
      allOptions: channelArray,
      checkedList: isoChecked,
      onChecked: showSurfaces,
      onUnchecked: hideSurfaces
      // keep checkboxes lined up when channel rows have settings icon and headers don't
      ,
      style: {
        flex: 5
      }
    }, "All Surf"));
  };
  var renderChannelRow = function renderChannelRow(channelIndex) {
    var thisChannelSettings = channelSettings[channelIndex];
    return thisChannelSettings ? /*#__PURE__*/React.createElement(ChannelsWidgetRow, {
      key: "".concat(channelIndex, "_").concat(thisChannelSettings.name, "_").concat(channelIndex),
      index: channelIndex,
      channelDataForChannel: channelDataChannels[channelIndex],
      name: getDisplayName(thisChannelSettings.name, channelIndex, viewerChannelSettings),
      channelState: thisChannelSettings,
      changeChannelSetting: props.changeChannelSetting,
      onColorChangeComplete: props.onColorChangeComplete,
      saveIsosurface: props.saveIsosurface
    }) : null;
  };
  var firstKey = Object.keys(channelGroupedByType)[0];
  var rows = channelDataChannels && Object.entries(channelGroupedByType).filter(function (_ref) {
    var _ref2 = _slicedToArray(_ref, 2),
      key = _ref2[0],
      channelArray = _ref2[1];
    return channelArray.length > 0 && (!filterFunc || filterFunc(key));
  }).map(function (_ref3) {
    var _ref4 = _slicedToArray(_ref3, 2),
      key = _ref4[0],
      channelArray = _ref4[1];
    var children = /*#__PURE__*/React.createElement(List, {
      itemLayout: "horizontal",
      dataSource: channelArray,
      renderItem: renderChannelRow
    });
    return {
      key: key,
      label: key,
      children: children,
      extra: renderVisibilityControls(channelArray)
    };
  });
  return /*#__PURE__*/React.createElement(Collapse, {
    bordered: false,
    defaultActiveKey: firstKey,
    items: rows,
    collapsible: "icon"
  });
};
export default connectToViewerState(ChannelsWidget, ["channelSettings", "changeChannelSetting"]);