function _slicedToArray(r, e) { return _arrayWithHoles(r) || _iterableToArrayLimit(r, e) || _unsupportedIterableToArray(r, e) || _nonIterableRest(); }
function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _unsupportedIterableToArray(r, a) { if (r) { if ("string" == typeof r) return _arrayLikeToArray(r, a); var t = {}.toString.call(r).slice(8, -1); return "Object" === t && r.constructor && (t = r.constructor.name), "Map" === t || "Set" === t ? Array.from(r) : "Arguments" === t || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(t) ? _arrayLikeToArray(r, a) : void 0; } }
function _arrayLikeToArray(r, a) { (null == a || a > r.length) && (a = r.length); for (var e = 0, n = Array(a); e < a; e++) n[e] = r[e]; return n; }
function _iterableToArrayLimit(r, l) { var t = null == r ? null : "undefined" != typeof Symbol && r[Symbol.iterator] || r["@@iterator"]; if (null != t) { var e, n, i, u, a = [], f = !0, o = !1; try { if (i = (t = t.call(r)).next, 0 === l) { if (Object(t) !== t) return; f = !1; } else for (; !(f = (e = i.call(t)).done) && (a.push(e.value), a.length !== l); f = !0); } catch (r) { o = !0, n = r; } finally { try { if (!f && null != t["return"] && (u = t["return"](), Object(u) !== u)) return; } finally { if (o) throw n; } } return a; } }
function _arrayWithHoles(r) { if (Array.isArray(r)) return r; }
import React, { useState, useCallback } from "react";
import { Button, List, Checkbox } from "antd";
import TfEditor from "../TfEditor";
import { ISOSURFACE_OPACITY_SLIDER_MAX } from "../../shared/constants";
import ColorPicker from "../ColorPicker";
import { colorObjectToArray, colorArrayToObject } from "../../shared/utils/colorRepresentations";
import ViewerIcon from "../shared/ViewerIcon";
import SliderRow from "../shared/SliderRow";
import "./styles.css";
var ChannelsWidgetRow = function ChannelsWidgetRow(props) {
  var index = props.index,
    changeChannelSetting = props.changeChannelSetting,
    saveIsosurface = props.saveIsosurface,
    channelState = props.channelState;
  var _useState = useState(false),
    _useState2 = _slicedToArray(_useState, 2),
    controlsOpen = _useState2[0],
    setControlsOpen = _useState2[1];
  var changeSettingForThisChannel = useCallback(function (value) {
    return changeChannelSetting(index, value);
  }, [changeChannelSetting, index]);
  var volumeCheckHandler = function volumeCheckHandler(_ref) {
    var target = _ref.target;
    changeChannelSetting(index, {
      "volumeEnabled": target.checked
    });
  };
  var isosurfaceCheckHandler = function isosurfaceCheckHandler(_ref2) {
    var target = _ref2.target;
    changeChannelSetting(index, {
      "isosurfaceEnabled": target.checked
    });
  };
  var onIsovalueChange = function onIsovalueChange(_ref3) {
    var _ref4 = _slicedToArray(_ref3, 1),
      newValue = _ref4[0];
    return changeSettingForThisChannel({
      "isovalue": newValue
    });
  };
  var onOpacityChange = function onOpacityChange(_ref5) {
    var _ref6 = _slicedToArray(_ref5, 1),
      newValue = _ref6[0];
    return changeSettingForThisChannel({
      "opacity": newValue / ISOSURFACE_OPACITY_SLIDER_MAX
    });
  };
  var onColorChange = function onColorChange(newRGB, _oldRGB, index) {
    var color = colorObjectToArray(newRGB);
    props.changeChannelSetting(index, {
      "color": color
    });
  };
  var createColorPicker = function createColorPicker() {
    return /*#__PURE__*/React.createElement(ColorPicker, {
      color: colorArrayToObject(channelState.color),
      onColorChange: onColorChange,
      onColorChangeComplete: props.onColorChangeComplete,
      disableAlpha: true,
      idx: index,
      width: 18
    });
  };
  var visibilityControls = /*#__PURE__*/React.createElement("div", {
    className: "channel-visibility-controls"
  }, /*#__PURE__*/React.createElement(Checkbox, {
    checked: channelState.volumeEnabled,
    onChange: volumeCheckHandler
  }, "Vol"), /*#__PURE__*/React.createElement(Checkbox, {
    checked: channelState.isosurfaceEnabled,
    onChange: isosurfaceCheckHandler
  }, "Surf"), /*#__PURE__*/React.createElement(Button, {
    icon: /*#__PURE__*/React.createElement(ViewerIcon, {
      type: "preferences",
      style: {
        fontSize: "16px"
      }
    }),
    onClick: function onClick() {
      return setControlsOpen(!controlsOpen);
    },
    title: "Open channel settings",
    type: "text"
  }));
  var createTFEditor = function createTFEditor() {
    var controlPoints = channelState.controlPoints,
      colorizeEnabled = channelState.colorizeEnabled,
      colorizeAlpha = channelState.colorizeAlpha,
      useControlPoints = channelState.useControlPoints,
      ramp = channelState.ramp;
    return /*#__PURE__*/React.createElement(TfEditor, {
      id: "TFEditor" + index,
      width: 418,
      height: 145,
      channelData: props.channelDataForChannel,
      controlPoints: controlPoints,
      changeChannelSetting: changeSettingForThisChannel,
      colorizeEnabled: colorizeEnabled,
      colorizeAlpha: colorizeAlpha,
      useControlPoints: useControlPoints,
      ramp: ramp
    });
  };
  var renderSurfaceControls = function renderSurfaceControls() {
    return /*#__PURE__*/React.createElement("div", null, /*#__PURE__*/React.createElement(SliderRow, {
      label: "Isovalue",
      max: 255,
      start: channelState.isovalue,
      onChange: onIsovalueChange,
      formatInteger: true
    }), /*#__PURE__*/React.createElement(SliderRow, {
      label: "Opacity",
      max: ISOSURFACE_OPACITY_SLIDER_MAX,
      start: channelState.opacity * ISOSURFACE_OPACITY_SLIDER_MAX,
      onChange: onOpacityChange,
      formatInteger: true
    }), /*#__PURE__*/React.createElement("div", {
      className: "button-row"
    }, /*#__PURE__*/React.createElement(Button, {
      onClick: function onClick() {
        return saveIsosurface(index, "GLTF");
      }
    }, "Export GLTF"), /*#__PURE__*/React.createElement(Button, {
      onClick: function onClick() {
        return saveIsosurface(index, "STL");
      }
    }, "Export STL")));
  };
  var renderControls = function renderControls() {
    if (!channelState.volumeEnabled && !channelState.isosurfaceEnabled) {
      return /*#__PURE__*/React.createElement("h4", {
        style: {
          fontStyle: "italic"
        }
      }, "Not currently visible");
    }
    return /*#__PURE__*/React.createElement(React.Fragment, null, channelState.volumeEnabled && /*#__PURE__*/React.createElement(React.Fragment, null, /*#__PURE__*/React.createElement("h4", null, "Volume settings:"), createTFEditor()), channelState.isosurfaceEnabled && /*#__PURE__*/React.createElement(React.Fragment, null, /*#__PURE__*/React.createElement("h4", null, "Surface settings:"), renderSurfaceControls()));
  };
  var rowClass = controlsOpen ? "channel-row" : "channel-row controls-closed";
  return /*#__PURE__*/React.createElement(List.Item, {
    key: index,
    className: rowClass
  }, /*#__PURE__*/React.createElement(List.Item.Meta, {
    title: props.name,
    avatar: createColorPicker()
  }), visibilityControls, controlsOpen && /*#__PURE__*/React.createElement("div", {
    style: {
      width: "100%"
    }
  }, renderControls()));
};
export default ChannelsWidgetRow;