function _typeof(o) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (o) { return typeof o; } : function (o) { return o && "function" == typeof Symbol && o.constructor === Symbol && o !== Symbol.prototype ? "symbol" : typeof o; }, _typeof(o); }
function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { _defineProperty(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
function _defineProperty(e, r, t) { return (r = _toPropertyKey(r)) in e ? Object.defineProperty(e, r, { value: t, enumerable: !0, configurable: !0, writable: !0 }) : e[r] = t, e; }
function _toPropertyKey(t) { var i = _toPrimitive(t, "string"); return "symbol" == _typeof(i) ? i : i + ""; }
function _toPrimitive(t, r) { if ("object" != _typeof(t) || !t) return t; var e = t[Symbol.toPrimitive]; if (void 0 !== e) { var i = e.call(t, r || "default"); if ("object" != _typeof(i)) return i; throw new TypeError("@@toPrimitive must return a primitive value."); } return ("string" === r ? String : Number)(t); }
function _slicedToArray(r, e) { return _arrayWithHoles(r) || _iterableToArrayLimit(r, e) || _unsupportedIterableToArray(r, e) || _nonIterableRest(); }
function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _unsupportedIterableToArray(r, a) { if (r) { if ("string" == typeof r) return _arrayLikeToArray(r, a); var t = {}.toString.call(r).slice(8, -1); return "Object" === t && r.constructor && (t = r.constructor.name), "Map" === t || "Set" === t ? Array.from(r) : "Arguments" === t || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(t) ? _arrayLikeToArray(r, a) : void 0; } }
function _arrayLikeToArray(r, a) { (null == a || a > r.length) && (a = r.length); for (var e = 0, n = Array(a); e < a; e++) n[e] = r[e]; return n; }
function _iterableToArrayLimit(r, l) { var t = null == r ? null : "undefined" != typeof Symbol && r[Symbol.iterator] || r["@@iterator"]; if (null != t) { var e, n, i, u, a = [], f = !0, o = !1; try { if (i = (t = t.call(r)).next, 0 === l) { if (Object(t) !== t) return; f = !1; } else for (; !(f = (e = i.call(t)).done) && (a.push(e.value), a.length !== l); f = !0); } catch (r) { o = !0, n = r; } finally { try { if (!f && null != t["return"] && (u = t["return"](), Object(u) !== u)) return; } finally { if (o) throw n; } } return a; } }
function _arrayWithHoles(r) { if (Array.isArray(r)) return r; }
import React from "react";
import { SketchPicker } from "react-color";
import { map } from "lodash";
// if there are fewer than this many screen pixels below the swatch but more above, open above the swatch
var OPEN_ABOVE_MARGIN = 310;
var DEFAULT_COLOR = {
  r: "241",
  g: "112",
  b: "19",
  a: "1"
};
var ColorPicker = function ColorPicker(props) {
  var _React$useState = React.useState(false),
    _React$useState2 = _slicedToArray(_React$useState, 2),
    isOpen = _React$useState2[0],
    setIsOpen = _React$useState2[1];
  var _React$useState3 = React.useState(false),
    _React$useState4 = _slicedToArray(_React$useState3, 2),
    openAboveSwatch = _React$useState4[0],
    setOpenAboveSwatch = _React$useState4[1];
  var _React$useState5 = React.useState(props.color || DEFAULT_COLOR),
    _React$useState6 = _slicedToArray(_React$useState5, 2),
    currentColor = _React$useState6[0],
    setCurrentColor = _React$useState6[1];
  var swatchRef = React.useRef(null);
  var handleClick = function handleClick() {
    var swatchRect = swatchRef.current.getBoundingClientRect();
    var noRoomBelowSwatch = swatchRect.bottom > window.innerHeight - OPEN_ABOVE_MARGIN;
    setIsOpen(!isOpen);
    setOpenAboveSwatch(noRoomBelowSwatch && swatchRect.top > OPEN_ABOVE_MARGIN);
  };
  var handleClose = function handleClose() {
    return setIsOpen(false);
  };
  var handleChange = function handleChange(color) {
    var _props$onColorChange;
    setCurrentColor(color.rgb);
    // supply onColorChange callback in props.
    (_props$onColorChange = props.onColorChange) === null || _props$onColorChange === void 0 || _props$onColorChange.call(props, color.rgb, currentColor, props.idx);
  };
  var handleChangeComplete = function handleChangeComplete(color) {
    var _props$onColorChangeC;
    setCurrentColor(color.rgb);
    // supply onColorChange callback in props.
    (_props$onColorChangeC = props.onColorChangeComplete) === null || _props$onColorChangeC === void 0 || _props$onColorChangeC.call(props, color.rgb, currentColor, props.idx);
  };
  React.useEffect(function () {
    return setCurrentColor(props.color);
  }, [props.color]);
  var width = props.width || 36;
  var popoverDirectionStyle = openAboveSwatch ? {
    bottom: "21px"
  } : {
    top: "0px"
  };
  return /*#__PURE__*/React.createElement("div", null, /*#__PURE__*/React.createElement("div", {
    style: STYLES.swatch,
    ref: swatchRef,
    onClick: handleClick
  }, /*#__PURE__*/React.createElement("div", {
    style: _objectSpread(_objectSpread({}, STYLES.color), {}, {
      width: "".concat(width, "px"),
      background: "rgba(".concat(map(currentColor, function (ele) {
        return ele;
      }), ")")
    })
  })), /*#__PURE__*/React.createElement("div", {
    style: {
      position: "absolute"
    }
  }, isOpen ? /*#__PURE__*/React.createElement("div", {
    style: _objectSpread(_objectSpread({}, STYLES.popover), popoverDirectionStyle)
  }, /*#__PURE__*/React.createElement("div", {
    style: STYLES.cover,
    onClick: handleClose
  }), /*#__PURE__*/React.createElement(SketchPicker, {
    color: currentColor,
    onChange: handleChange,
    onChangeComplete: handleChangeComplete,
    disableAlpha: props.disableAlpha
  })) : null));
};
export default ColorPicker;
var STYLES = {
  color: {
    height: "14px",
    margin: "3px",
    borderRadius: "2px"
  },
  swatch: {
    borderRadius: "3px",
    border: "1px solid var(--color-controlpanel-border)",
    display: "inline-block",
    cursor: "pointer",
    verticalAlign: "middle"
  },
  popover: {
    position: "absolute",
    zIndex: "9999"
  },
  cover: {
    position: "fixed",
    top: "0px",
    right: "0px",
    bottom: "0px",
    left: "0px"
  }
};