function _extends() { return _extends = Object.assign ? Object.assign.bind() : function (n) { for (var e = 1; e < arguments.length; e++) { var t = arguments[e]; for (var r in t) ({}).hasOwnProperty.call(t, r) && (n[r] = t[r]); } return n; }, _extends.apply(null, arguments); }
function _typeof(o) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (o) { return typeof o; } : function (o) { return o && "function" == typeof Symbol && o.constructor === Symbol && o !== Symbol.prototype ? "symbol" : typeof o; }, _typeof(o); }
function _slicedToArray(r, e) { return _arrayWithHoles(r) || _iterableToArrayLimit(r, e) || _unsupportedIterableToArray(r, e) || _nonIterableRest(); }
function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _unsupportedIterableToArray(r, a) { if (r) { if ("string" == typeof r) return _arrayLikeToArray(r, a); var t = {}.toString.call(r).slice(8, -1); return "Object" === t && r.constructor && (t = r.constructor.name), "Map" === t || "Set" === t ? Array.from(r) : "Arguments" === t || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(t) ? _arrayLikeToArray(r, a) : void 0; } }
function _arrayLikeToArray(r, a) { (null == a || a > r.length) && (a = r.length); for (var e = 0, n = Array(a); e < a; e++) n[e] = r[e]; return n; }
function _iterableToArrayLimit(r, l) { var t = null == r ? null : "undefined" != typeof Symbol && r[Symbol.iterator] || r["@@iterator"]; if (null != t) { var e, n, i, u, a = [], f = !0, o = !1; try { if (i = (t = t.call(r)).next, 0 === l) { if (Object(t) !== t) return; f = !1; } else for (; !(f = (e = i.call(t)).done) && (a.push(e.value), a.length !== l); f = !0); } catch (r) { o = !0, n = r; } finally { try { if (!f && null != t["return"] && (u = t["return"](), Object(u) !== u)) return; } finally { if (o) throw n; } } return a; } }
function _arrayWithHoles(r) { if (Array.isArray(r)) return r; }
function _defineProperty(e, r, t) { return (r = _toPropertyKey(r)) in e ? Object.defineProperty(e, r, { value: t, enumerable: !0, configurable: !0, writable: !0 }) : e[r] = t, e; }
function _toPropertyKey(t) { var i = _toPrimitive(t, "string"); return "symbol" == _typeof(i) ? i : i + ""; }
function _toPrimitive(t, r) { if ("object" != _typeof(t) || !t) return t; var e = t[Symbol.toPrimitive]; if (void 0 !== e) { var i = e.call(t, r || "default"); if ("object" != _typeof(i)) return i; throw new TypeError("@@toPrimitive must return a primitive value."); } return ("string" === r ? String : Number)(t); }
import React from "react";
import { Button, Dropdown, Tooltip, Collapse, Flex } from "antd";
import ChannelsWidget from "../ChannelsWidget";
import GlobalVolumeControls from "../GlobalVolumeControls";
import CustomizeWidget from "../CustomizeWidget";
import MetadataViewer from "../MetadataViewer";
import { PRESET_COLOR_MAP } from "../../shared/constants";
import "./styles.css";
import ViewerIcon from "../shared/ViewerIcon";
import { connectToViewerState } from "../ViewerStateProvider";
var ControlTab = /*#__PURE__*/function (ControlTab) {
  ControlTab[ControlTab["Channels"] = 0] = "Channels";
  ControlTab[ControlTab["Advanced"] = 1] = "Advanced";
  ControlTab[ControlTab["Metadata"] = 2] = "Metadata";
  return ControlTab;
}(ControlTab || {});
var ControlTabNames = _defineProperty(_defineProperty(_defineProperty({}, ControlTab.Channels, "Channel Settings"), ControlTab.Advanced, "Advanced Settings"), ControlTab.Metadata, "Metadata");
function ControlPanel(props) {
  var _React$useState = React.useState(ControlTab.Channels),
    _React$useState2 = _slicedToArray(_React$useState, 2),
    tab = _React$useState2[0],
    setTab = _React$useState2[1];
  var controlPanelContainerRef = React.useRef(null);
  var getDropdownContainer = controlPanelContainerRef.current ? function () {
    return controlPanelContainerRef.current;
  } : undefined;
  var viewerChannelSettings = props.viewerChannelSettings,
    visibleControls = props.visibleControls,
    hasImage = props.hasImage;

  // TODO key is a number, but MenuInfo assumes keys will always be strings
  //   if future versions of antd make this type more permissive, remove ugly double-cast
  var makeTurnOnPresetFn = function makeTurnOnPresetFn(_ref) {
    var key = _ref.key;
    return props.onApplyColorPresets(PRESET_COLOR_MAP[key].colors);
  };
  var renderColorPresetsDropdown = function renderColorPresetsDropdown() {
    var dropDownMenuProps = {
      items: PRESET_COLOR_MAP.map(function (preset, index) {
        return {
          key: index,
          label: preset.name
        };
      }),
      onClick: makeTurnOnPresetFn
    };
    return /*#__PURE__*/React.createElement("div", {
      className: "color-presets-dropdown"
    }, /*#__PURE__*/React.createElement(Dropdown, {
      trigger: ["click"],
      menu: dropDownMenuProps,
      getPopupContainer: getDropdownContainer
    }, /*#__PURE__*/React.createElement(Button, null, /*#__PURE__*/React.createElement("div", {
      style: {
        display: "flex",
        flexDirection: "row",
        alignItems: "center",
        gap: "4px"
      }
    }, "Apply palette", /*#__PURE__*/React.createElement(ViewerIcon, {
      type: "dropdownArrow",
      style: {
        fontSize: "14px"
      }
    })))));
  };
  var renderTab = function renderTab(thisTab, icon) {
    return /*#__PURE__*/React.createElement(Tooltip, _extends({
      title: ControlTabNames[thisTab],
      placement: "right"
    }, !props.collapsed && {
      open: false
    }), /*#__PURE__*/React.createElement(Button, {
      className: tab === thisTab ? "ant-btn-icon-only btn-tabactive" : "ant-btn-icon-only",
      onClick: function onClick() {
        return setTab(thisTab);
      },
      icon: typeof icon === "string" ? icon : undefined
    }, _typeof(icon) === "object" && icon));
  };
  var renderAdvancedSettings = function renderAdvancedSettings() {
    var items = [{
      key: 0,
      label: "Rendering adjustments",
      children: /*#__PURE__*/React.createElement(GlobalVolumeControls, {
        imageName: props.imageName,
        pixelSize: props.pixelSize,
        visibleControls: visibleControls
      })
    }];
    var showCustomize = visibleControls.backgroundColorPicker || visibleControls.boundingBoxColorPicker;
    if (showCustomize) {
      items.push({
        key: 1,
        label: "Customize",
        children: /*#__PURE__*/React.createElement(CustomizeWidget, {
          visibleControls: props.visibleControls
        })
      });
    }
    return /*#__PURE__*/React.createElement(Flex, {
      gap: 10,
      vertical: true
    }, /*#__PURE__*/React.createElement(Collapse, {
      bordered: false,
      defaultActiveKey: showCustomize ? [0, 1] : 0,
      items: items
    }), /*#__PURE__*/React.createElement("div", {
      style: {
        margin: "0 10px",
        width: "fit-content"
      }
    }, /*#__PURE__*/React.createElement(Tooltip, {
      trigger: ["hover", "focus"],
      placement: "right",
      title: "Clears ALL rendering settings and channel configuration to the default viewer state. This will replace any edits to channel settings, color presets, and rendering adjustments."
    }, /*#__PURE__*/React.createElement(Button, {
      onClick: props.resetToDefaultViewerState
    }, "Clear all settings"))));
  };
  return /*#__PURE__*/React.createElement("div", {
    className: "control-panel-col-container",
    ref: controlPanelContainerRef
  }, /*#__PURE__*/React.createElement("div", {
    className: "control-panel-tab-col",
    style: {
      flex: "0 0 50px"
    }
  }, /*#__PURE__*/React.createElement(Button, {
    className: "ant-btn-icon-only btn-collapse" + (props.collapsed ? " btn-collapse-collapsed" : ""),
    onClick: function onClick() {
      return props.setCollapsed(!props.collapsed);
    }
  }, /*#__PURE__*/React.createElement(ViewerIcon, {
    type: "closePanel"
  })), /*#__PURE__*/React.createElement("div", {
    className: "tab-divider"
  }), renderTab(ControlTab.Channels, /*#__PURE__*/React.createElement(ViewerIcon, {
    type: "channels"
  })), renderTab(ControlTab.Advanced, /*#__PURE__*/React.createElement(ViewerIcon, {
    type: "preferences"
  })), props.visibleControls.metadataViewer && renderTab(ControlTab.Metadata, /*#__PURE__*/React.createElement(ViewerIcon, {
    type: "metadata"
  }))), /*#__PURE__*/React.createElement("div", {
    className: "control-panel-col",
    style: {
      flex: "0 0 450px"
    }
  }, /*#__PURE__*/React.createElement("h2", {
    className: "control-panel-title"
  }, ControlTabNames[tab]), visibleControls.colorPresetsDropdown && tab === ControlTab.Channels && renderColorPresetsDropdown(), hasImage && /*#__PURE__*/React.createElement("div", {
    className: "channel-rows-list"
  }, tab === ControlTab.Channels && /*#__PURE__*/React.createElement(ChannelsWidget, {
    channelDataChannels: props.channelDataChannels,
    channelGroupedByType: props.channelGroupedByType,
    saveIsosurface: props.saveIsosurface,
    onColorChangeComplete: props.onColorChangeComplete,
    onApplyColorPresets: props.onApplyColorPresets,
    filterFunc: props.filterFunc,
    viewerChannelSettings: viewerChannelSettings
  }), tab === ControlTab.Advanced && renderAdvancedSettings(), tab === ControlTab.Metadata && /*#__PURE__*/React.createElement(MetadataViewer, {
    metadata: props.getMetadata()
  }))));
}
export default connectToViewerState(ControlPanel, ["resetToDefaultViewerState"]);