import React from "react";
import ColorPicker from "./ColorPicker";
import { colorArrayToObject, colorObjectToArray } from "../shared/utils/colorRepresentations";
import { connectToViewerState } from "./ViewerStateProvider";
var ColorPickerRow = function ColorPickerRow(_ref) {
  var color = _ref.color,
    _onColorChange = _ref.onColorChange,
    children = _ref.children;
  return /*#__PURE__*/React.createElement("div", {
    style: STYLES.colorPickerRow
  }, /*#__PURE__*/React.createElement("span", {
    style: STYLES.colorPicker
  }, /*#__PURE__*/React.createElement(ColorPicker, {
    color: colorArrayToObject(color),
    onColorChange: function onColorChange(color) {
      return _onColorChange(colorObjectToArray(color));
    },
    width: 18,
    disableAlpha: true
  })), /*#__PURE__*/React.createElement("span", null, children));
};
var CustomizeWidget = function CustomizeWidget(props) {
  return /*#__PURE__*/React.createElement(React.Fragment, null, props.visibleControls.backgroundColorPicker && /*#__PURE__*/React.createElement(ColorPickerRow, {
    color: props.backgroundColor,
    onColorChange: function onColorChange(color) {
      return props.changeViewerSetting("backgroundColor", color);
    }
  }, "Background color"), props.visibleControls.boundingBoxColorPicker && /*#__PURE__*/React.createElement(ColorPickerRow, {
    color: props.boundingBoxColor,
    onColorChange: function onColorChange(color) {
      return props.changeViewerSetting("boundingBoxColor", color);
    }
  }, "Bounding box color", !props.showBoundingBox && /*#__PURE__*/React.createElement("i", null, " - bounding box turned off")));
};
var STYLES = {
  colorPickerRow: {
    padding: "14px 0",
    display: "flex",
    borderBottom: "1px solid #6e6e6e",
    color: "var(--color-controlpanel-text)"
  },
  colorPicker: {
    marginRight: "16px"
  }
};
export default connectToViewerState(CustomizeWidget, ["showBoundingBox", "backgroundColor", "boundingBoxColor", "changeViewerSetting"]);