function _typeof(o) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (o) { return typeof o; } : function (o) { return o && "function" == typeof Symbol && o.constructor === Symbol && o !== Symbol.prototype ? "symbol" : typeof o; }, _typeof(o); }
function _toConsumableArray(r) { return _arrayWithoutHoles(r) || _iterableToArray(r) || _unsupportedIterableToArray(r) || _nonIterableSpread(); }
function _nonIterableSpread() { throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _iterableToArray(r) { if ("undefined" != typeof Symbol && null != r[Symbol.iterator] || null != r["@@iterator"]) return Array.from(r); }
function _arrayWithoutHoles(r) { if (Array.isArray(r)) return _arrayLikeToArray(r); }
function _slicedToArray(r, e) { return _arrayWithHoles(r) || _iterableToArrayLimit(r, e) || _unsupportedIterableToArray(r, e) || _nonIterableRest(); }
function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _unsupportedIterableToArray(r, a) { if (r) { if ("string" == typeof r) return _arrayLikeToArray(r, a); var t = {}.toString.call(r).slice(8, -1); return "Object" === t && r.constructor && (t = r.constructor.name), "Map" === t || "Set" === t ? Array.from(r) : "Arguments" === t || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(t) ? _arrayLikeToArray(r, a) : void 0; } }
function _arrayLikeToArray(r, a) { (null == a || a > r.length) && (a = r.length); for (var e = 0, n = Array(a); e < a; e++) n[e] = r[e]; return n; }
function _iterableToArrayLimit(r, l) { var t = null == r ? null : "undefined" != typeof Symbol && r[Symbol.iterator] || r["@@iterator"]; if (null != t) { var e, n, i, u, a = [], f = !0, o = !1; try { if (i = (t = t.call(r)).next, 0 === l) { if (Object(t) !== t) return; f = !1; } else for (; !(f = (e = i.call(t)).done) && (a.push(e.value), a.length !== l); f = !0); } catch (r) { o = !0, n = r; } finally { try { if (!f && null != t["return"] && (u = t["return"](), Object(u) !== u)) return; } finally { if (o) throw n; } } return a; } }
function _arrayWithHoles(r) { if (Array.isArray(r)) return r; }
function _defineProperty(e, r, t) { return (r = _toPropertyKey(r)) in e ? Object.defineProperty(e, r, { value: t, enumerable: !0, configurable: !0, writable: !0 }) : e[r] = t, e; }
function _toPropertyKey(t) { var i = _toPrimitive(t, "string"); return "symbol" == _typeof(i) ? i : i + ""; }
function _toPrimitive(t, r) { if ("object" != _typeof(t) || !t) return t; var e = t[Symbol.toPrimitive]; if (void 0 !== e) { var i = e.call(t, r || "default"); if ("object" != _typeof(i)) return i; throw new TypeError("@@toPrimitive must return a primitive value."); } return ("string" === r ? String : Number)(t); }
import { VolumeLoadErrorType } from "@aics/volume-viewer";
import { RightOutlined } from "@ant-design/icons";
import { Alert, Button } from "antd";
import React from "react";
import { useConstructor } from "../../shared/utils/hooks";
import "./styles.css";
var IssueLink = function IssueLink(_ref) {
  var bug = _ref.bug,
    children = _ref.children;
  return /*#__PURE__*/React.createElement("a", {
    href: "https://github.com/allen-cell-animated/website-3d-cell-viewer/issues/new".concat(bug ? "?template=bug_report.md" : "/choose"),
    target: "_blank",
    rel: "noreferrer noopener"
  }, children);
};
var UNKNOWN_ERROR_DESCRIPTION = /*#__PURE__*/React.createElement(React.Fragment, null, "An unknown error occurred. Check the browser console (F12) for more details. If this looks like a bug,", " ", /*#__PURE__*/React.createElement(IssueLink, {
  bug: true
}, "send us a bug report here"), ".");
var ERROR_TYPE_DESCRIPTIONS = _defineProperty(_defineProperty(_defineProperty(_defineProperty(_defineProperty(_defineProperty({}, VolumeLoadErrorType.UNKNOWN, /*#__PURE__*/React.createElement(React.Fragment, null, "An unknown error occurred while loading volume data. Check the browser console (F12) for more details. If this looks like a bug, ", /*#__PURE__*/React.createElement(IssueLink, {
  bug: true
}, "send us a bug report here"), ".")), VolumeLoadErrorType.NOT_FOUND, /*#__PURE__*/React.createElement(React.Fragment, null, "The viewer was unable to find any volume data at the specified location. Check that the provided URL is correct and try again.")), VolumeLoadErrorType.TOO_LARGE, /*#__PURE__*/React.createElement(React.Fragment, null, "No scale level is available for this volume which fits within our maximum GPU memory footprint. This maximum is tuned to ensure compatibility with the majority of browsers. If you're trying to load your own OME-Zarr dataset, you may be able to open this volume by including a lower scale level.")), VolumeLoadErrorType.LOAD_DATA_FAILED, /*#__PURE__*/React.createElement(React.Fragment, null, "The viewer was able to find a source of volume data at the specified location, but encountered an error while trying to load it. Check that your dataset is complete and properly formatted. You can also check the browser console (F12) for more details about this error. If it looks like a problem on our end,", " ", /*#__PURE__*/React.createElement(IssueLink, {
  bug: true
}, "start a bug report here"), ".")), VolumeLoadErrorType.INVALID_METADATA, /*#__PURE__*/React.createElement(React.Fragment, null, "The viewer was unable to read all necessary information from this volume's metadata. Check that your dataset's metadata is complete and properly formatted. If you believe your data is valid and should be supported by our viewer, let us know by ", /*#__PURE__*/React.createElement(IssueLink, null, "opening a GitHub issue"), ".")), VolumeLoadErrorType.INVALID_MULTI_SOURCE_ZARR, /*#__PURE__*/React.createElement(React.Fragment, null, "The viewer is currently configured to consolidate multiple OME-Zarr datasets into a single volume, but the provided datasets can't all be matched up. Ensure that all dataset URLs are correct and that at least one equivalently-sized scale level exists in all datasets."));
var getErrorTitle = function getErrorTitle(error) {
  var _error$toString;
  return error instanceof Error && ((_error$toString = error.toString) === null || _error$toString === void 0 ? void 0 : _error$toString.call(error)) || "Unknown error";
};
var getErrorDescription = function getErrorDescription(error) {
  var _ERROR_TYPE_DESCRIPTI2;
  var type = error.type;
  if (!type) {
    return UNKNOWN_ERROR_DESCRIPTION;
  }
  return (_ERROR_TYPE_DESCRIPTI2 = ERROR_TYPE_DESCRIPTIONS[type]) !== null && _ERROR_TYPE_DESCRIPTI2 !== void 0 ? _ERROR_TYPE_DESCRIPTI2 : UNKNOWN_ERROR_DESCRIPTION;
};
var ErrorAlert = function ErrorAlert(_ref2) {
  var errors = _ref2.errors,
    _ref2$firstErrorCount = _ref2.firstErrorCount,
    firstErrorCount = _ref2$firstErrorCount === void 0 ? 0 : _ref2$firstErrorCount,
    _afterClose = _ref2.afterClose,
    onSkipError = _ref2.onSkipError;
  var _React$useState = React.useState(false),
    _React$useState2 = _slicedToArray(_React$useState, 2),
    showDetails = _React$useState2[0],
    setShowDetails = _React$useState2[1];
  var _React$useState3 = React.useState(0),
    _React$useState4 = _slicedToArray(_React$useState3, 2),
    errorsSeenCount = _React$useState4[0],
    setErrorsSeenCount = _React$useState4[1];
  var error = Array.isArray(errors) ? errors[0] : errors;
  var errorMessage = /*#__PURE__*/React.createElement(React.Fragment, null, /*#__PURE__*/React.createElement("div", null, getErrorTitle(error) + (firstErrorCount > 1 ? " (".concat(firstErrorCount, ")") : ""), " ", /*#__PURE__*/React.createElement(Button, {
    type: "text",
    onClick: function onClick() {
      return setShowDetails(!showDetails);
    }
  }, showDetails ? "Show less info" : "Show more info")), /*#__PURE__*/React.createElement("div", {
    style: {
      display: showDetails ? undefined : "none"
    }
  }, getErrorDescription(error)));
  var skipErrorButton = Array.isArray(errors) && errors.length > 1 && /*#__PURE__*/React.createElement(Button, {
    type: "text",
    onClick: function onClick() {
      setErrorsSeenCount(function (count) {
        return count + 1;
      });
      onSkipError === null || onSkipError === void 0 || onSkipError();
    }
  }, "Error ", errorsSeenCount + 1, " of ", errors.length + errorsSeenCount, " ", /*#__PURE__*/React.createElement(RightOutlined, null));
  return /*#__PURE__*/React.createElement(Alert, {
    showIcon: true,
    type: "error",
    className: "load-error-alert",
    message: errorMessage,
    closable: true,
    afterClose: function afterClose() {
      setErrorsSeenCount(0);
      _afterClose === null || _afterClose === void 0 || _afterClose();
    },
    action: skipErrorButton
  });
};
export var useErrorAlert = function useErrorAlert() {
  var _React$useState5 = React.useState([]),
    _React$useState6 = _slicedToArray(_React$useState5, 2),
    errorList = _React$useState6[0],
    setErrorList = _React$useState6[1];
  // Keep track of which errors have been seen and how many times
  var seenErrors = useConstructor(function () {
    return new Map();
  });
  var _React$useState7 = React.useState([]),
    _React$useState8 = _slicedToArray(_React$useState7, 2),
    errorCounts = _React$useState8[0],
    setErrorCounts = _React$useState8[1];
  var addError = React.useCallback(function (error) {
    var _seenErrors$get;
    console.error(error);
    var errorTitle = getErrorTitle(error);
    var errorSeenCount = ((_seenErrors$get = seenErrors.get(errorTitle)) !== null && _seenErrors$get !== void 0 ? _seenErrors$get : 0) + 1;
    setErrorList(function (prev) {
      return [].concat(_toConsumableArray(prev), [error]);
    });
    setErrorCounts(function (prev) {
      return [].concat(_toConsumableArray(prev), [errorSeenCount]);
    });
    seenErrors.set(errorTitle, errorSeenCount);
  }, []);
  var onSkipError = React.useCallback(function () {
    setErrorList(function (prev) {
      return prev.slice(1);
    });
    setErrorCounts(function (prev) {
      return prev.slice(1);
    });
  }, []);
  var afterClose = React.useCallback(function () {
    setErrorList([]);
    setErrorCounts([]);
  }, []);
  var errCount = errorCounts[0];
  var alertComponent = errorList.length > 0 && /*#__PURE__*/React.createElement(ErrorAlert, {
    errors: errorList,
    firstErrorCount: errCount,
    onSkipError: onSkipError,
    afterClose: afterClose
  });
  return [alertComponent, addError];
};
export default ErrorAlert;