import React from "react";
import { Checkbox } from "antd";
import SliderRow from "./shared/SliderRow";
import { connectToViewerState } from "./ViewerStateProvider";
var GlobalVolumeControls = function GlobalVolumeControls(props) {
  var createSliderRow = function createSliderRow(label, start, max, propKey) {
    var onUpdate = function onUpdate(_strValues, _handle, values) {
      var selectValue = values.length === 1 ? values[0] : values;
      props.changeViewerSetting(propKey, selectValue);
    };
    return /*#__PURE__*/React.createElement(SliderRow, {
      label: label,
      start: start,
      max: max,
      onUpdate: onUpdate
    });
  };
  var showControls = props.visibleControls,
    maskAlpha = props.maskAlpha,
    brightness = props.brightness,
    density = props.density,
    levels = props.levels;
  return /*#__PURE__*/React.createElement("div", {
    style: {
      paddingTop: 18,
      paddingBottom: 22
    }
  }, showControls.alphaMaskSlider && createSliderRow("mask cell", maskAlpha, 100, "maskAlpha"), showControls.brightnessSlider && createSliderRow("brightness", brightness, 100, "brightness"), showControls.densitySlider && createSliderRow("density", density, 100, "density"), showControls.levelsSliders && createSliderRow("levels", levels, 255, "levels"), showControls.interpolationControl && /*#__PURE__*/React.createElement(SliderRow, {
    label: "interpolate"
  }, /*#__PURE__*/React.createElement(Checkbox, {
    checked: props.interpolationEnabled,
    onChange: function onChange(_ref) {
      var target = _ref.target;
      return props.changeViewerSetting("interpolationEnabled", target.checked);
    }
  })));
};
export default connectToViewerState(GlobalVolumeControls, ["maskAlpha", "brightness", "density", "levels", "interpolationEnabled", "changeViewerSetting"]);