function _slicedToArray(r, e) { return _arrayWithHoles(r) || _iterableToArrayLimit(r, e) || _unsupportedIterableToArray(r, e) || _nonIterableRest(); }
function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _unsupportedIterableToArray(r, a) { if (r) { if ("string" == typeof r) return _arrayLikeToArray(r, a); var t = {}.toString.call(r).slice(8, -1); return "Object" === t && r.constructor && (t = r.constructor.name), "Map" === t || "Set" === t ? Array.from(r) : "Arguments" === t || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(t) ? _arrayLikeToArray(r, a) : void 0; } }
function _arrayLikeToArray(r, a) { (null == a || a > r.length) && (a = r.length); for (var e = 0, n = Array(a); e < a; e++) n[e] = r[e]; return n; }
function _iterableToArrayLimit(r, l) { var t = null == r ? null : "undefined" != typeof Symbol && r[Symbol.iterator] || r["@@iterator"]; if (null != t) { var e, n, i, u, a = [], f = !0, o = !1; try { if (i = (t = t.call(r)).next, 0 === l) { if (Object(t) !== t) return; f = !1; } else for (; !(f = (e = i.call(t)).done) && (a.push(e.value), a.length !== l); f = !0); } catch (r) { o = !0, n = r; } finally { try { if (!f && null != t["return"] && (u = t["return"](), Object(u) !== u)) return; } finally { if (o) throw n; } } return a; } }
function _arrayWithHoles(r) { if (Array.isArray(r)) return r; }
function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { _defineProperty(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
function _defineProperty(e, r, t) { return (r = _toPropertyKey(r)) in e ? Object.defineProperty(e, r, { value: t, enumerable: !0, configurable: !0, writable: !0 }) : e[r] = t, e; }
function _toPropertyKey(t) { var i = _toPrimitive(t, "string"); return "symbol" == _typeof(i) ? i : i + ""; }
function _toPrimitive(t, r) { if ("object" != _typeof(t) || !t) return t; var e = t[Symbol.toPrimitive]; if (void 0 !== e) { var i = e.call(t, r || "default"); if ("object" != _typeof(i)) return i; throw new TypeError("@@toPrimitive must return a primitive value."); } return ("string" === r ? String : Number)(t); }
function _typeof(o) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (o) { return typeof o; } : function (o) { return o && "function" == typeof Symbol && o.constructor === Symbol && o !== Symbol.prototype ? "symbol" : typeof o; }, _typeof(o); }
import { RightOutlined } from "@ant-design/icons";
import React from "react";
import "./styles.css";
var isCategory = function isCategory(entry) {
  return _typeof(entry) === "object" && entry !== null;
};
var sortCategoriesFirst = function sortCategoriesFirst(entry) {
  if (!isCategory(entry) || Array.isArray(entry)) {
    return entry;
  }
  var cats = {};
  var vals = {};
  for (var key in entry) {
    if (isCategory(entry[key])) {
      cats[key] = entry[key];
    } else {
      vals[key] = entry[key];
    }
  }
  return _objectSpread(_objectSpread({}, cats), vals);
};

/** Component to hold collapse state */
var MetadataCategory = function MetadataCategory(_ref) {
  var metadata = _ref.metadata,
    title = _ref.title;
  var _React$useState = React.useState(true),
    _React$useState2 = _slicedToArray(_React$useState, 2),
    collapsed = _React$useState2[0],
    setCollapsed = _React$useState2[1];
  var collapsedClass = collapsed ? " metadata-collapse-collapsed" : "";
  return /*#__PURE__*/React.createElement(React.Fragment, null, /*#__PURE__*/React.createElement("tr", {
    className: "metadata-row-collapse-title" + collapsedClass,
    onClick: function onClick() {
      return setCollapsed(!collapsed);
    }
  }, /*#__PURE__*/React.createElement("td", {
    colSpan: 2
  }, /*#__PURE__*/React.createElement("span", {
    className: "metadata-collapse-caret"
  }, /*#__PURE__*/React.createElement(RightOutlined, {
    style: {
      transform: "rotate(".concat(collapsed ? 0 : 90, "deg)")
    }
  })), title)), /*#__PURE__*/React.createElement("tr", {
    className: "metadata-row-collapse-content" + collapsedClass
  }, /*#__PURE__*/React.createElement("td", {
    className: "metadata-collapse-content",
    colSpan: 2
  }, /*#__PURE__*/React.createElement(MetadataTable, {
    metadata: metadata
  }))));
};
var MetadataTable = function MetadataTable(_ref2) {
  var metadata = _ref2.metadata,
    topLevel = _ref2.topLevel;
  var metadataKeys = Object.keys(metadata);
  var metadataIsArray = Array.isArray(metadata);
  return /*#__PURE__*/React.createElement("table", {
    className: "viewer-metadata-table" + (topLevel ? " metadata-top-level" : "")
  }, /*#__PURE__*/React.createElement("tbody", null, metadataKeys.map(function (key, idx) {
    var metadataValue = sortCategoriesFirst(metadataIsArray ? metadata[idx] : metadata[key]);
    if (isCategory(metadataValue)) {
      return /*#__PURE__*/React.createElement(MetadataCategory, {
        key: key,
        metadata: metadataValue,
        title: key
      });
    } else {
      return /*#__PURE__*/React.createElement("tr", {
        key: key
      }, /*#__PURE__*/React.createElement("td", {
        className: "metadata-key"
      }, key), /*#__PURE__*/React.createElement("td", {
        className: "metadata-value"
      }, metadataValue + ""));
    }
  })));
};
var MetadataViewer = function MetadataViewer(_ref3) {
  var metadata = _ref3.metadata;
  return /*#__PURE__*/React.createElement(MetadataTable, {
    metadata: metadata,
    topLevel: true
  });
};
export default MetadataViewer;