import React from "react";
import { Dropdown, Button, Tooltip } from "antd";
import ViewerIcon from "../shared/ViewerIcon";
var DownloadButton = function DownloadButton(_ref) {
  var fovDownloadHref = _ref.fovDownloadHref,
    cellDownloadHref = _ref.cellDownloadHref,
    hasFov = _ref.hasFov;
  if (hasFov) {
    var menu = {
      className: "download-dropdown",
      items: [{
        key: "1",
        label: /*#__PURE__*/React.createElement("a", {
          href: cellDownloadHref
        }, /*#__PURE__*/React.createElement(ViewerIcon, {
          type: "download"
        }), " Segmented cell")
      }, {
        key: "2",
        label: /*#__PURE__*/React.createElement("a", {
          href: fovDownloadHref
        }, /*#__PURE__*/React.createElement(ViewerIcon, {
          type: "download"
        }), " Full field image")
      }]
    };
    return /*#__PURE__*/React.createElement(Tooltip, {
      trigger: ["hover", "focus"],
      placement: "bottom",
      title: "Download volume data"
    }, /*#__PURE__*/React.createElement(Dropdown, {
      menu: menu,
      placement: "bottomRight",
      trigger: ["click"]
    }, /*#__PURE__*/React.createElement(Button, {
      className: "ant-btn-icon-only btn-borderless"
    }, /*#__PURE__*/React.createElement(ViewerIcon, {
      type: "download"
    }))));
  } else if (cellDownloadHref) {
    return /*#__PURE__*/React.createElement(Tooltip, {
      trigger: ["hover", "focus"],
      placement: "bottom",
      title: "Download volume data"
    }, /*#__PURE__*/React.createElement(Button, {
      className: "ant-btn-icon-only btn-borderless",
      href: cellDownloadHref
    }, /*#__PURE__*/React.createElement(ViewerIcon, {
      type: "download"
    })));
  } else {
    return null;
  }
};
export default DownloadButton;