import React from "react";
import { Radio } from "antd";
import { ViewMode } from "../../shared/enums";
var viewModes = [ViewMode.threeD, ViewMode.xy, ViewMode.xz, ViewMode.yz];
var ViewModeRadioButtons = function ViewModeRadioButtons(props) {
  var onChangeButton = function onChangeButton(_ref) {
    var target = _ref.target;
    if (props.mode !== target.value) {
      props.onViewModeChange(target.value);
    }
  };
  return /*#__PURE__*/React.createElement(Radio.Group, {
    onChange: onChangeButton,
    value: props.mode.toString()
  }, viewModes.map(function (mode, index) {
    return /*#__PURE__*/React.createElement(Radio.Button, {
      key: index,
      value: mode.toString()
    }, mode);
  }));
};
export default ViewModeRadioButtons;