function _typeof(o) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (o) { return typeof o; } : function (o) { return o && "function" == typeof Symbol && o.constructor === Symbol && o !== Symbol.prototype ? "symbol" : typeof o; }, _typeof(o); }
function _classCallCheck(a, n) { if (!(a instanceof n)) throw new TypeError("Cannot call a class as a function"); }
function _defineProperties(e, r) { for (var t = 0; t < r.length; t++) { var o = r[t]; o.enumerable = o.enumerable || !1, o.configurable = !0, "value" in o && (o.writable = !0), Object.defineProperty(e, _toPropertyKey(o.key), o); } }
function _createClass(e, r, t) { return r && _defineProperties(e.prototype, r), t && _defineProperties(e, t), Object.defineProperty(e, "prototype", { writable: !1 }), e; }
function _callSuper(t, o, e) { return o = _getPrototypeOf(o), _possibleConstructorReturn(t, _isNativeReflectConstruct() ? Reflect.construct(o, e || [], _getPrototypeOf(t).constructor) : o.apply(t, e)); }
function _possibleConstructorReturn(t, e) { if (e && ("object" == _typeof(e) || "function" == typeof e)) return e; if (void 0 !== e) throw new TypeError("Derived constructors may only return object or undefined"); return _assertThisInitialized(t); }
function _assertThisInitialized(e) { if (void 0 === e) throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); return e; }
function _isNativeReflectConstruct() { try { var t = !Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); } catch (t) {} return (_isNativeReflectConstruct = function _isNativeReflectConstruct() { return !!t; })(); }
function _getPrototypeOf(t) { return _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf.bind() : function (t) { return t.__proto__ || Object.getPrototypeOf(t); }, _getPrototypeOf(t); }
function _inherits(t, e) { if ("function" != typeof e && null !== e) throw new TypeError("Super expression must either be null or a function"); t.prototype = Object.create(e && e.prototype, { constructor: { value: t, writable: !0, configurable: !0 } }), Object.defineProperty(t, "prototype", { writable: !1 }), e && _setPrototypeOf(t, e); }
function _setPrototypeOf(t, e) { return _setPrototypeOf = Object.setPrototypeOf ? Object.setPrototypeOf.bind() : function (t, e) { return t.__proto__ = e, t; }, _setPrototypeOf(t, e); }
function _defineProperty(e, r, t) { return (r = _toPropertyKey(r)) in e ? Object.defineProperty(e, r, { value: t, enumerable: !0, configurable: !0, writable: !0 }) : e[r] = t, e; }
function _toPropertyKey(t) { var i = _toPrimitive(t, "string"); return "symbol" == _typeof(i) ? i : i + ""; }
function _toPrimitive(t, r) { if ("object" != _typeof(t) || !t) return t; var e = t[Symbol.toPrimitive]; if (void 0 !== e) { var i = e.call(t, r || "default"); if ("object" != _typeof(i)) return i; throw new TypeError("@@toPrimitive must return a primitive value."); } return ("string" === r ? String : Number)(t); }
import { UndoOutlined } from "@ant-design/icons";
import { Button, Radio, Select, Tooltip } from "antd";
import { debounce } from "lodash";
import React from "react";
import ViewModeRadioButtons from "./ViewModeRadioButtons";
import DownloadButton from "./DownloadButton";
import { connectToViewerState } from "../ViewerStateProvider";
import { ImageType, RenderMode, ViewMode } from "../../shared/enums";
import ViewerIcon from "../shared/ViewerIcon";
import "./styles.css";
var RESIZE_DEBOUNCE_DELAY = 50;
var visuallyHiddenStyle = {
  position: "absolute",
  width: "1px",
  height: "1px",
  padding: "0",
  margin: "-1px",
  overflow: "hidden",
  clip: "rect(0, 0, 0, 0)",
  whiteSpace: "nowrap",
  borderWidth: "0"
};
var Toolbar = /*#__PURE__*/function (_React$Component) {
  function Toolbar(props) {
    var _this;
    _classCallCheck(this, Toolbar);
    _this = _callSuper(this, Toolbar, [props]);
    _defineProperty(_this, "checkSize", debounce(function () {
      var _this2 = _this,
        leftRef = _this2.leftRef,
        centerRef = _this2.centerRef,
        rightRef = _this2.rightRef,
        barRef = _this2.barRef;
      if (!leftRef.current || !centerRef.current || !rightRef.current || !barRef.current) {
        return;
      }
      var leftRect = leftRef.current.getBoundingClientRect();
      var centerRect = centerRef.current.getBoundingClientRect();
      var rightRect = rightRef.current.getBoundingClientRect();

      // when calculating width required to leave scroll mode, add a bit of extra width to ensure that triggers
      // for entering and leaving scroll mode never overlap (causing toolbar to rapidly switch when resizing)
      var SCROLL_OFF_EXTRA_WIDTH = 15;
      if (_this.state.scrollMode) {
        // Leave scroll mode if there is enough space for centered controls not to overlap left/right-aligned ones
        var barWidth = barRef.current.getBoundingClientRect().width;
        var requiredWidth = Math.max(leftRect.width, rightRect.width) * 2 + centerRect.width + SCROLL_OFF_EXTRA_WIDTH;
        if (barWidth > requiredWidth) {
          _this.setState({
            scrollMode: false
          });
        }
      } else {
        // Enter scroll mode if centered controls are overlapping either left/right-aligned ones
        if (leftRect.right > centerRect.left || centerRect.right > rightRect.left) {
          _this.setState({
            scrollMode: true
          });
        }
      }
      _this.checkScrollBtnVisible();
    }, RESIZE_DEBOUNCE_DELAY));
    _defineProperty(_this, "scrollX", function (amount) {
      return _this.barRef.current.scrollLeft += amount;
    });
    // Translate vertical scrolling into horizontal scrolling
    _defineProperty(_this, "wheelHandler", function (e) {
      e.preventDefault();
      if (e.deltaY === 0) {
        return;
      }
      _this.scrollX(e.deltaY);
    });
    // Scroll buttons are only visible when toolbar can be scrolled in that direction.
    // This may change on either scroll or resize.
    _defineProperty(_this, "checkScrollBtnVisible", function () {
      var barEl = _this.barRef.current;
      if (!barEl) {
        return;
      }
      var scrollBtnLeft = barEl.scrollLeft > 0;
      var scrollBtnRight = barEl.scrollLeft < barEl.scrollWidth - barEl.clientWidth;
      if (scrollBtnLeft !== _this.state.scrollBtnLeft || scrollBtnRight !== _this.state.scrollBtnRight) {
        _this.setState({
          scrollBtnLeft: scrollBtnLeft,
          scrollBtnRight: scrollBtnRight
        });
      }
    });
    _defineProperty(_this, "toggleAxis", function () {
      return _this.props.changeViewerSetting("showAxes", !_this.props.showAxes);
    });
    _defineProperty(_this, "toggleBoundingBox", function () {
      return _this.props.changeViewerSetting("showBoundingBox", !_this.props.showBoundingBox);
    });
    // TODO remove ant-btn-icon-only hack when upgrading antd
    _defineProperty(_this, "classForToggleBtn", function (active) {
      return "ant-btn-icon-only btn-borderless" + (active ? " btn-active" : "");
    });
    _this.state = {
      scrollMode: false,
      scrollBtnLeft: false,
      scrollBtnRight: false
    };
    _this.containerRef = /*#__PURE__*/React.createRef();
    _this.barRef = /*#__PURE__*/React.createRef();
    _this.leftRef = /*#__PURE__*/React.createRef();
    _this.rightRef = /*#__PURE__*/React.createRef();
    _this.centerRef = /*#__PURE__*/React.createRef();
    window.addEventListener("resize", _this.checkSize);
    _this.checkSize();
    return _this;
  }
  _inherits(Toolbar, _React$Component);
  return _createClass(Toolbar, [{
    key: "render",
    value: function render() {
      var _this3 = this;
      var props = this.props;
      var changeViewerSetting = props.changeViewerSetting,
        resetToSavedViewerState = props.resetToSavedViewerState,
        visibleControls = props.visibleControls,
        showAxes = props.showAxes,
        showBoundingBox = props.showBoundingBox,
        autorotate = props.autorotate;
      var _this$state = this.state,
        scrollMode = _this$state.scrollMode,
        scrollBtnLeft = _this$state.scrollBtnLeft,
        scrollBtnRight = _this$state.scrollBtnRight;
      var twoDMode = props.viewMode !== ViewMode.threeD;
      var renderGroup1 = visibleControls.viewModeRadioButtons || visibleControls.resetCameraButton || visibleControls.autoRotateButton;
      var renderGroup4 = visibleControls.showAxesButton || visibleControls.showBoundingBoxButton;
      var axesToggleTitle = showAxes ? "Hide axes" : "Show axes";
      var boundingBoxToggleTitle = showBoundingBox ? "Hide bounding box" : "Show bounding box";
      var turntableToggleTitle = autorotate ? "Turn off turntable" : "Turn on turntable";
      var getPopupContainer = this.containerRef.current ? function () {
        return _this3.containerRef.current;
      } : undefined;
      return /*#__PURE__*/React.createElement("div", {
        className: "viewer-toolbar-container".concat(scrollMode ? " viewer-toolbar-scroll" : ""),
        ref: this.containerRef
      }, /*#__PURE__*/React.createElement("div", {
        className: "viewer-toolbar-scroll-left",
        style: {
          display: scrollBtnLeft ? "flex" : "none"
        },
        onClick: function onClick() {
          return _this3.scrollX(-100);
        }
      }, /*#__PURE__*/React.createElement(ViewerIcon, {
        type: "closePanel",
        style: {
          fontSize: "12px",
          transform: "rotate(180deg)"
        }
      })), /*#__PURE__*/React.createElement("div", {
        className: "viewer-toolbar",
        ref: this.barRef,
        onWheel: this.wheelHandler,
        onScroll: this.checkScrollBtnVisible
      }, /*#__PURE__*/React.createElement("div", {
        className: "viewer-toolbar-left",
        ref: this.leftRef
      }, /*#__PURE__*/React.createElement(Tooltip, {
        placement: "bottom",
        title: "Reset to initial settings",
        trigger: ["focus", "hover"]
      }, /*#__PURE__*/React.createElement(Button, {
        className: "ant-btn-icon-only btn-borderless",
        onClick: resetToSavedViewerState
      }, /*#__PURE__*/React.createElement(UndoOutlined, null), /*#__PURE__*/React.createElement("span", {
        style: visuallyHiddenStyle
      }, "Reset to initial settings")))), /*#__PURE__*/React.createElement("div", {
        className: "viewer-toolbar-center",
        ref: this.centerRef
      }, renderGroup1 && /*#__PURE__*/React.createElement("div", {
        className: "viewer-toolbar-group"
      }, visibleControls.viewModeRadioButtons && /*#__PURE__*/React.createElement(ViewModeRadioButtons, {
        mode: props.viewMode,
        onViewModeChange: function onViewModeChange(newMode) {
          return changeViewerSetting("viewMode", newMode);
        }
      }), visibleControls.resetCameraButton && /*#__PURE__*/React.createElement(Tooltip, {
        placement: "bottom",
        title: "Reset camera"
      }, /*#__PURE__*/React.createElement(Button, {
        className: "ant-btn-icon-only btn-borderless",
        onClick: props.resetCamera
      }, /*#__PURE__*/React.createElement(ViewerIcon, {
        type: "resetView"
      }))), visibleControls.autoRotateButton && /*#__PURE__*/React.createElement(Tooltip, {
        placement: "bottom",
        title: turntableToggleTitle
      }, /*#__PURE__*/React.createElement(Button, {
        className: this.classForToggleBtn(autorotate && !twoDMode),
        disabled: twoDMode || props.renderMode === RenderMode.pathTrace,
        onClick: function onClick() {
          return changeViewerSetting("autorotate", !autorotate);
        }
      }, /*#__PURE__*/React.createElement(ViewerIcon, {
        type: "turnTable"
      })))), visibleControls.fovCellSwitchControls && props.hasCellId && props.hasParentImage && /*#__PURE__*/React.createElement("div", {
        className: "viewer-toolbar-group"
      }, /*#__PURE__*/React.createElement(Radio.Group, {
        value: props.imageType,
        onChange: function onChange(_ref) {
          var target = _ref.target;
          return changeViewerSetting("imageType", target.value);
        }
      }, /*#__PURE__*/React.createElement(Radio.Button, {
        value: ImageType.segmentedCell
      }, "Single cell"), /*#__PURE__*/React.createElement(Radio.Button, {
        value: ImageType.fullField
      }, "Full field"))), /*#__PURE__*/React.createElement("div", {
        className: "viewer-toolbar-group"
      }, /*#__PURE__*/React.createElement(Select, {
        className: "select-render-setting",
        popupClassName: "viewer-toolbar-dropdown",
        value: props.renderMode,
        onChange: function onChange(value) {
          return changeViewerSetting("renderMode", value);
        },
        getPopupContainer: getPopupContainer
      }, /*#__PURE__*/React.createElement(Select.Option, {
        value: RenderMode.volumetric,
        key: RenderMode.volumetric
      }, "Volumetric"), props.canPathTrace && /*#__PURE__*/React.createElement(Select.Option, {
        value: RenderMode.pathTrace,
        key: RenderMode.pathTrace,
        disabled: twoDMode
      }, "Path trace"), /*#__PURE__*/React.createElement(Select.Option, {
        value: RenderMode.maxProject,
        key: RenderMode.maxProject
      }, "Max project"))), renderGroup4 && /*#__PURE__*/React.createElement("div", {
        className: "viewer-toolbar-group"
      }, visibleControls.showAxesButton && /*#__PURE__*/React.createElement(Tooltip, {
        placement: "bottom",
        title: axesToggleTitle
      }, /*#__PURE__*/React.createElement(Button, {
        className: this.classForToggleBtn(showAxes),
        onClick: this.toggleAxis
      }, /*#__PURE__*/React.createElement(ViewerIcon, {
        type: "axes"
      }))), visibleControls.showBoundingBoxButton && /*#__PURE__*/React.createElement(Tooltip, {
        placement: "bottom",
        title: boundingBoxToggleTitle
      }, /*#__PURE__*/React.createElement(Button, {
        className: this.classForToggleBtn(showBoundingBox),
        onClick: this.toggleBoundingBox
      }, /*#__PURE__*/React.createElement(ViewerIcon, {
        type: "boundingBox"
      }))))), /*#__PURE__*/React.createElement("div", {
        className: "viewer-toolbar-right viewer-toolbar-group",
        ref: this.rightRef
      }, /*#__PURE__*/React.createElement(Tooltip, {
        placement: "bottom",
        title: "Download"
      }, /*#__PURE__*/React.createElement(DownloadButton, {
        cellDownloadHref: props.cellDownloadHref,
        fovDownloadHref: props.fovDownloadHref,
        hasFov: props.hasCellId && props.hasParentImage
      })), /*#__PURE__*/React.createElement(Tooltip, {
        placement: "bottom",
        title: "Screenshot"
      }, /*#__PURE__*/React.createElement(Button, {
        className: "ant-btn-icon-only btn-borderless",
        onClick: props.downloadScreenshot
      }, /*#__PURE__*/React.createElement(ViewerIcon, {
        type: "camera"
      }))))), /*#__PURE__*/React.createElement("div", {
        className: "viewer-toolbar-scroll-right",
        style: {
          display: scrollBtnRight ? "flex" : "none"
        },
        onClick: function onClick() {
          return _this3.scrollX(100);
        }
      }, /*#__PURE__*/React.createElement(ViewerIcon, {
        type: "closePanel",
        style: {
          fontSize: "12px"
        }
      })));
    }
  }]);
}(React.Component);
export default connectToViewerState(Toolbar, ["imageType", "renderMode", "viewMode", "autorotate", "showAxes", "showBoundingBox", "changeViewerSetting", "resetToSavedViewerState"]);