function _typeof(o) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (o) { return typeof o; } : function (o) { return o && "function" == typeof Symbol && o.constructor === Symbol && o !== Symbol.prototype ? "symbol" : typeof o; }, _typeof(o); }
function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { _defineProperty(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
function _defineProperty(e, r, t) { return (r = _toPropertyKey(r)) in e ? Object.defineProperty(e, r, { value: t, enumerable: !0, configurable: !0, writable: !0 }) : e[r] = t, e; }
function _createForOfIteratorHelper(r, e) { var t = "undefined" != typeof Symbol && r[Symbol.iterator] || r["@@iterator"]; if (!t) { if (Array.isArray(r) || (t = _unsupportedIterableToArray(r)) || e && r && "number" == typeof r.length) { t && (r = t); var _n = 0, F = function F() {}; return { s: F, n: function n() { return _n >= r.length ? { done: !0 } : { done: !1, value: r[_n++] }; }, e: function e(r) { throw r; }, f: F }; } throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); } var o, a = !0, u = !1; return { s: function s() { t = t.call(r); }, n: function n() { var r = t.next(); return a = r.done, r; }, e: function e(r) { u = !0, o = r; }, f: function f() { try { a || null == t["return"] || t["return"](); } finally { if (u) throw o; } } }; }
function _unsupportedIterableToArray(r, a) { if (r) { if ("string" == typeof r) return _arrayLikeToArray(r, a); var t = {}.toString.call(r).slice(8, -1); return "Object" === t && r.constructor && (t = r.constructor.name), "Map" === t || "Set" === t ? Array.from(r) : "Arguments" === t || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(t) ? _arrayLikeToArray(r, a) : void 0; } }
function _arrayLikeToArray(r, a) { (null == a || a > r.length) && (a = r.length); for (var e = 0, n = Array(a); e < a; e++) n[e] = r[e]; return n; }
function _classCallCheck(a, n) { if (!(a instanceof n)) throw new TypeError("Cannot call a class as a function"); }
function _defineProperties(e, r) { for (var t = 0; t < r.length; t++) { var o = r[t]; o.enumerable = o.enumerable || !1, o.configurable = !0, "value" in o && (o.writable = !0), Object.defineProperty(e, _toPropertyKey(o.key), o); } }
function _createClass(e, r, t) { return r && _defineProperties(e.prototype, r), t && _defineProperties(e, t), Object.defineProperty(e, "prototype", { writable: !1 }), e; }
function _toPropertyKey(t) { var i = _toPrimitive(t, "string"); return "symbol" == _typeof(i) ? i : i + ""; }
function _toPrimitive(t, r) { if ("object" != _typeof(t) || !t) return t; var e = t[Symbol.toPrimitive]; if (void 0 !== e) { var i = e.call(t, r || "default"); if ("object" != _typeof(i)) return i; throw new TypeError("@@toPrimitive must return a primitive value."); } return ("string" === r ? String : Number)(t); }
import { isEqual } from "lodash";
import { getDefaultViewerState, getDefaultCameraState, getDefaultChannelState, getDefaultViewerChannelSettings, getDefaultChannelColor } from "../../shared/constants";
import { ViewMode } from "../../shared/enums";
import { overrideViewerState, overrideChannelStates, getEnabledChannelIndices, initializeOneChannelSetting } from "../../shared/utils/viewerState";
/**
 * Provides reset functionality for the viewer and channel states.
 */
var ResetStateProvider = /*#__PURE__*/function () {
  function ResetStateProvider(viewerStateRef) {
    _classCallCheck(this, ResetStateProvider);
    this.ref = viewerStateRef;
    this.savedViewerState = {};
    this.channelsToReset = new Set();
    this.channelsToResetOnLoad = new Set();
    this.savedViewerChannelSettings = undefined;
    this.useDefaultViewerChannelSettings = false;
    this.resetToSavedViewerState = this.resetToSavedViewerState.bind(this);
    this.resetToDefaultViewerState = this.resetToDefaultViewerState.bind(this);
    this.resetToState = this.resetToState.bind(this);
    this.setSavedViewerState = this.setSavedViewerState.bind(this);
    this.setSavedViewerChannelSettings = this.setSavedViewerChannelSettings.bind(this);
    this.getChannelsAwaitingReset = this.getChannelsAwaitingReset.bind(this);
    this.getChannelsAwaitingResetOnLoad = this.getChannelsAwaitingResetOnLoad.bind(this);
    this.onResetChannel = this.onResetChannel.bind(this);
    this.getCurrentViewerChannelSettings = this.getCurrentViewerChannelSettings.bind(this);
  }

  // Setup Callbacks ////////////////////////////////////////////////////////////////////
  return _createClass(ResetStateProvider, [{
    key: "setSavedViewerState",
    value: function setSavedViewerState(state) {
      this.savedViewerState = state;
    }
  }, {
    key: "setSavedViewerChannelSettings",
    value: function setSavedViewerChannelSettings(settings) {
      this.savedViewerChannelSettings = settings;
    }
  }, {
    key: "getChannelsAwaitingReset",
    value: function getChannelsAwaitingReset() {
      return this.channelsToReset;
    }
  }, {
    key: "getChannelsAwaitingResetOnLoad",
    value: function getChannelsAwaitingResetOnLoad() {
      return this.channelsToResetOnLoad;
    }
  }, {
    key: "onResetChannel",
    value: function onResetChannel(channelIndex) {
      this.channelsToReset["delete"](channelIndex);
      this.channelsToResetOnLoad["delete"](channelIndex);
    }

    /**
     * Returns the current viewer channel settings that the viewer should use when
     * resetting channels to an initial state.
     */
  }, {
    key: "getCurrentViewerChannelSettings",
    value: function getCurrentViewerChannelSettings() {
      if (this.useDefaultViewerChannelSettings) {
        return getDefaultViewerChannelSettings();
      }
      return this.savedViewerChannelSettings;
    }

    /**
     * Helper method. Resets the viewer and all channels to the provided state. If new data needs to
     * be loaded, handles setup so the reset will be applied to each channel as it loads in.
     */
  }, {
    key: "resetToState",
    value: function resetToState(newState, newChannelStates) {
      var _this$ref$current = this.ref.current,
        changeViewerSetting = _this$ref$current.changeViewerSetting,
        setChannelSettings = _this$ref$current.setChannelSettings,
        channelSettings = _this$ref$current.channelSettings,
        viewMode = _this$ref$current.viewMode,
        time = _this$ref$current.time,
        slice = _this$ref$current.slice;

      // Needs reset on reload if one of the view modes is 2D while the other is 3D,
      // if the timestamp is different, or if we're on a different z slice.
      // TODO: Handle stopping playback? Requires playback to be part of ViewerStateContext
      var isInDifferentViewMode = viewMode !== newState.viewMode && (viewMode === ViewMode.xy || newState.viewMode === ViewMode.xy);
      var isAtDifferentTime = time !== newState.time;
      var isAtDifferentZSlice = newState.viewMode === ViewMode.xy && !isEqual(newState.slice.z, slice.z);
      var willNeedResetOnLoad = isInDifferentViewMode || isAtDifferentTime || isAtDifferentZSlice;
      overrideViewerState(changeViewerSetting, newState);
      overrideChannelStates(setChannelSettings, channelSettings, newChannelStates);
      this.channelsToReset = new Set(Array(newChannelStates.length).keys());
      if (willNeedResetOnLoad) {
        var enabledChannelsAndResetState = getEnabledChannelIndices(newChannelStates);
        this.channelsToResetOnLoad = new Set(enabledChannelsAndResetState);
        var _iterator = _createForOfIteratorHelper(enabledChannelsAndResetState),
          _step;
        try {
          for (_iterator.s(); !(_step = _iterator.n()).done;) {
            var channelIndex = _step.value;
            this.channelsToReset["delete"](channelIndex);
          }
        } catch (err) {
          _iterator.e(err);
        } finally {
          _iterator.f();
        }
      }
    }

    /** Resets to the initial saved state of the viewer, as shown to the user on load. */
  }, {
    key: "resetToSavedViewerState",
    value: function resetToSavedViewerState() {
      var _this = this;
      var channelSettings = this.ref.current.channelSettings;
      var newViewerState = _objectSpread(_objectSpread({}, getDefaultViewerState()), {}, {
        cameraState: getDefaultCameraState(this.savedViewerState.viewMode || ViewMode.threeD)
      }, this.savedViewerState);
      var newChannelSettings = channelSettings.map(function (_, index) {
        var initialChannelSetting = initializeOneChannelSetting(channelSettings[index].name, index, getDefaultChannelColor(index), _this.savedViewerChannelSettings);
        return initialChannelSetting;
      });
      this.resetToState(newViewerState, newChannelSettings);
      this.useDefaultViewerChannelSettings = false;
    }

    /** Reset to global default viewer state, as if loading the volume with no parameters. */
  }, {
    key: "resetToDefaultViewerState",
    value: function resetToDefaultViewerState() {
      var channelSettings = this.ref.current.channelSettings;
      var defaultViewerState = _objectSpread(_objectSpread({}, getDefaultViewerState()), {}, {
        cameraState: getDefaultCameraState(ViewMode.threeD)
      });
      var defaultChannelStates = channelSettings.map(function (_, index) {
        return getDefaultChannelState(index);
      });
      for (var i = 0; i < Math.min(3, defaultChannelStates.length); i++) {
        defaultChannelStates[i].volumeEnabled = true;
      }
      this.resetToState(defaultViewerState, defaultChannelStates);
      this.useDefaultViewerChannelSettings = true;
    }
  }]);
}();
export { ResetStateProvider as default };