function _slicedToArray(r, e) { return _arrayWithHoles(r) || _iterableToArrayLimit(r, e) || _unsupportedIterableToArray(r, e) || _nonIterableRest(); }
function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _unsupportedIterableToArray(r, a) { if (r) { if ("string" == typeof r) return _arrayLikeToArray(r, a); var t = {}.toString.call(r).slice(8, -1); return "Object" === t && r.constructor && (t = r.constructor.name), "Map" === t || "Set" === t ? Array.from(r) : "Arguments" === t || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(t) ? _arrayLikeToArray(r, a) : void 0; } }
function _arrayLikeToArray(r, a) { (null == a || a > r.length) && (a = r.length); for (var e = 0, n = Array(a); e < a; e++) n[e] = r[e]; return n; }
function _iterableToArrayLimit(r, l) { var t = null == r ? null : "undefined" != typeof Symbol && r[Symbol.iterator] || r["@@iterator"]; if (null != t) { var e, n, i, u, a = [], f = !0, o = !1; try { if (i = (t = t.call(r)).next, 0 === l) { if (Object(t) !== t) return; f = !1; } else for (; !(f = (e = i.call(t)).done) && (a.push(e.value), a.length !== l); f = !0); } catch (r) { o = !0, n = r; } finally { try { if (!f && null != t["return"] && (u = t["return"](), Object(u) !== u)) return; } finally { if (o) throw n; } } return a; } }
function _arrayWithHoles(r) { if (Array.isArray(r)) return r; }
import React from "react";
import { CaretDownOutlined, CaretUpOutlined } from "@ant-design/icons";
import { useRefWithSetter } from "../../../shared/utils/hooks";
import "./styles.css";
/**
 * Fully-controlled numeric input (value must be supplied from state in parent).
 * Changeable with arrow keys, typing values, or clickable arrows. Inspired by
 * ant's `InputNumber`, but conforms to our style and behavior expectations.
 */
var NumericInput = function NumericInput(_ref) {
  var value = _ref.value,
    _ref$step = _ref.step,
    step = _ref$step === void 0 ? 1 : _ref$step,
    _ref$precision = _ref.precision,
    precision = _ref$precision === void 0 ? step : _ref$precision,
    _ref$min = _ref.min,
    min = _ref$min === void 0 ? 0 : _ref$min,
    _ref$max = _ref.max,
    max = _ref$max === void 0 ? Number.MAX_SAFE_INTEGER : _ref$max,
    _ref$disabled = _ref.disabled,
    disabled = _ref$disabled === void 0 ? false : _ref$disabled,
    _ref$className = _ref.className,
    className = _ref$className === void 0 ? "" : _ref$className,
    onChange = _ref.onChange;
  // While the input has focus, allow invalid input, just don't call `onChange` with it
  var _React$useState = React.useState(false),
    _React$useState2 = _slicedToArray(_React$useState, 2),
    hasFocus = _React$useState2[0],
    _setHasFocus = _React$useState2[1];
  // State doesn't update before focus handler runs - keep a ref following focus state
  var _useRefWithSetter = useRefWithSetter(_setHasFocus, hasFocus),
    _useRefWithSetter2 = _slicedToArray(_useRefWithSetter, 2),
    hasFocusRef = _useRefWithSetter2[0],
    setHasFocus = _useRefWithSetter2[1];

  // Hold the potentially invalid contents of the focused input here
  var _React$useState3 = React.useState(""),
    _React$useState4 = _slicedToArray(_React$useState3, 2),
    textContent = _React$useState4[0],
    setTextContent = _React$useState4[1];
  var inputRef = React.useRef(null);
  var clamp = function clamp(newValue) {
    return Math.min(Math.max(newValue, min), max);
  };
  var roundToPrecision = function roundToPrecision(newValue) {
    return clamp(Math.round(newValue / precision) * precision);
  };
  var shouldChange = function shouldChange(newValue) {
    return !(isNaN(newValue) || newValue === value || disabled);
  };
  var displayedValue = roundToPrecision(value);
  var onFocus = function onFocus() {
    if (!hasFocusRef.current) {
      // propagate current value to `textContent` on focus
      setTextContent(displayedValue.toString());
      setHasFocus(true);
    }
  };
  var changeByStep = function changeByStep(up) {
    var _inputRef$current;
    var delta = up ? step : -step;
    var newValue = clamp(displayedValue + delta);
    if (shouldChange(newValue)) {
      onChange(newValue);
      setTextContent(newValue.toString());
      // let the focus handler know we've taken care of things, so it won't restore the previous value
      setHasFocus(true);
    }
    (_inputRef$current = inputRef.current) === null || _inputRef$current === void 0 || _inputRef$current.focus();
  };
  var onKeyDown = function onKeyDown(event) {
    var key = event.key;
    if (["Up", "ArrowUp", "Down", "ArrowDown"].includes(key)) {
      changeByStep(key === "Up" || key === "ArrowUp");
      event.preventDefault();
    } else if (key === "Enter") {
      var _inputRef$current2;
      (_inputRef$current2 = inputRef.current) === null || _inputRef$current2 === void 0 || _inputRef$current2.blur();
    }
  };
  var handleTyping = function handleTyping(inputStr) {
    setTextContent(inputStr);

    // if the user clears all text, assume they mean 0 (or the extremum closest to it)
    // this is likely not completely general, but should be reasonable for any of our purposes
    var inputNum = inputStr === "" ? 0 : parseFloat(inputStr);
    var newValue = roundToPrecision(inputNum);
    if (shouldChange(newValue)) {
      onChange(newValue);
    }
  };
  var fullClassName = "numinput" + (disabled ? " numinput-disabled" : "") + (className && " ".concat(className));
  return /*#__PURE__*/React.createElement("div", {
    className: fullClassName,
    onKeyDown: onKeyDown
  }, /*#__PURE__*/React.createElement("input", {
    value: hasFocus ? textContent : displayedValue,
    step: step,
    min: min,
    max: max,
    disabled: disabled,
    className: "numinput-input",
    autoComplete: "off",
    role: "spinbutton",
    "aria-valuenow": displayedValue,
    "aria-valuemin": min,
    "aria-valuemax": max,
    ref: inputRef,
    onChange: function onChange(_ref2) {
      var target = _ref2.target;
      return handleTyping(target.value);
    },
    onFocus: onFocus,
    onBlur: function onBlur() {
      return setHasFocus(false);
    }
  }), /*#__PURE__*/React.createElement("div", {
    className: "numinput-controls"
  }, /*#__PURE__*/React.createElement("div", {
    className: "numinput-controls-button numinput-controls-button-up",
    role: "button",
    "aria-label": "Increase Value",
    "aria-disabled": disabled,
    onClick: function onClick() {
      return changeByStep(true);
    }
  }, /*#__PURE__*/React.createElement(CaretUpOutlined, {
    className: "numinput-controls-button-icon"
  })), /*#__PURE__*/React.createElement("div", {
    className: "numinput-controls-button numinput-controls-button-down",
    role: "button",
    "aria-label": "Decrease Value",
    "aria-disabled": disabled,
    onClick: function onClick() {
      return changeByStep(false);
    }
  }, /*#__PURE__*/React.createElement(CaretDownOutlined, {
    className: "numinput-controls-button-icon"
  }))));
};
export default NumericInput;