import React from "react";
import SmarterSlider from "../SmarterSlider";
import "./styles.css";
var INTEGER_FORMATTER = {
  to: Math.round,
  from: Number
};

/** A component to ensure a single unified style across the many labeled slider rows in the control panel */
var SliderRow = function SliderRow(props) {
  return /*#__PURE__*/React.createElement("div", {
    className: "viewer-control-row"
  }, /*#__PURE__*/React.createElement("div", {
    className: "control-name"
  }, props.label), /*#__PURE__*/React.createElement("div", {
    className: "control"
  }, props.start === undefined ? props.children : !props.hideSlider && /*#__PURE__*/React.createElement(SmarterSlider, {
    range: {
      min: 0,
      max: props.max
    },
    start: props.start,
    connect: true,
    tooltips: true,
    behaviour: "drag",
    format: props.formatInteger ? INTEGER_FORMATTER : undefined,
    onUpdate: props.onUpdate,
    onChange: props.onChange
  })));
};
export default SliderRow;