function _typeof(o) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (o) { return typeof o; } : function (o) { return o && "function" == typeof Symbol && o.constructor === Symbol && o !== Symbol.prototype ? "symbol" : typeof o; }, _typeof(o); }
function _defineProperty(e, r, t) { return (r = _toPropertyKey(r)) in e ? Object.defineProperty(e, r, { value: t, enumerable: !0, configurable: !0, writable: !0 }) : e[r] = t, e; }
function _toPropertyKey(t) { var i = _toPrimitive(t, "string"); return "symbol" == _typeof(i) ? i : i + ""; }
function _toPrimitive(t, r) { if ("object" != _typeof(t) || !t) return t; var e = t[Symbol.toPrimitive]; if (void 0 !== e) { var i = e.call(t, r || "default"); if ("object" != _typeof(i)) return i; throw new TypeError("@@toPrimitive must return a primitive value."); } return ("string" === r ? String : Number)(t); }
import { ImageType, RenderMode, ViewMode } from "./enums";
// Add all exported constants here to prevent circular dependencies
export var
  // Control panel will automatically close if viewport is less than this width
  CONTROL_PANEL_CLOSE_WIDTH = 970,
  BACKGROUND_COLOR_DEFAULT = [0, 0, 0],
  BOUNDING_BOX_COLOR_DEFAULT = [255, 255, 255],
  AXIS_MARGIN_DEFAULT = [16, 16],
  SCALE_BAR_MARGIN_DEFAULT = [120, 12],
  // These settings were chosen to work well with most AICS microscopy pipeline images.
  // These numbers mean: remap the bottom LUT_MIN_PERCENTILE fraction of pixels to zero intensity,
  // and linearly increase intensity up to the LUT_MAX_PERCENTILE fraction of pixels.
  LUT_MIN_PERCENTILE = 0.5,
  LUT_MAX_PERCENTILE = 0.983,
  ISOSURFACE_OPACITY_SLIDER_MAX = 255.0,
  ALPHA_MASK_SLIDER_DEFAULT = 0,
  BRIGHTNESS_SLIDER_LEVEL_DEFAULT = 70,
  DENSITY_SLIDER_LEVEL_DEFAULT = 50,
  LEVELS_SLIDER_DEFAULT = [35.0, 140.0, 255.0],
  INTERPOLATION_ENABLED_DEFAULT = true,
  OTHER_CHANNEL_KEY = "Other",
  SINGLE_GROUP_CHANNEL_KEY = "Channels";
export var TFEDITOR_DEFAULT_COLOR = [255, 255, 255];
export var TFEDITOR_MAX_BIN = 255;
export var CACHE_MAX_SIZE = 1000000000;
export var QUEUE_MAX_SIZE = 10;
export var QUEUE_MAX_LOW_PRIORITY_SIZE = 4;
export var PRESET_COLORS_1 = [[190, 68, 171], [189, 211, 75], [61, 155, 169], [128, 128, 128], [255, 255, 255], [239, 27, 45], [238, 77, 245], [96, 255, 255]];
export var PRESET_COLORS_2 = [[128, 0, 0], [0, 128, 0], [0, 0, 128], [32, 32, 32], [255, 255, 0], [255, 0, 255], [0, 255, 0], [0, 0, 255]];
export var PRESET_COLORS_3 = [[128, 0, 128], [128, 128, 128], [0, 128, 128], [128, 128, 0], [255, 255, 255], [255, 0, 0], [255, 0, 255], [0, 255, 255]];
export var PRESET_COLORS_0 = [[226, 205, 179], [111, 186, 17], [141, 163, 192], [245, 241, 203], [224, 227, 209], [221, 155, 245], [227, 244, 245], [255, 98, 0], [247, 219, 120]];
export var PRESET_COLOR_MAP = Object.freeze([{
  colors: PRESET_COLORS_0,
  name: "Default"
}, {
  colors: PRESET_COLORS_1,
  name: "Thumbnail colors"
}, {
  colors: PRESET_COLORS_2,
  name: "RGB colors"
}, {
  colors: PRESET_COLORS_3,
  name: "White structure"
}]);

/** Allows the 3D viewer to apply the default camera settings for the view mode. */
var USE_VIEW_MODE_DEFAULT_CAMERA = undefined;
var viewModeToDefaultCameraPosition = _defineProperty(_defineProperty(_defineProperty(_defineProperty({}, ViewMode.threeD, [0, 0, 5]), ViewMode.xy, [0, 0, 2]), ViewMode.xz, [0, 2, 0]), ViewMode.yz, [2, 0, 0]);
var viewModeToDefaultCameraUp = _defineProperty(_defineProperty(_defineProperty(_defineProperty({}, ViewMode.threeD, [0, 1, 0]), ViewMode.xy, [0, 1, 0]), ViewMode.xz, [0, 0, 1]), ViewMode.yz, [0, 0, 1]);

/**
 * Reflects the default camera settings the 3D viewer uses on volume load.
 * These SHOULD NOT be changed; otherwise, existing shared links that don't specify the
 * camera settings will use the new defaults and may be in unexpected orientations or positions.
 */
export var getDefaultCameraState = function getDefaultCameraState() {
  var viewMode = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : ViewMode.threeD;
  return {
    // Default position varies by view mode
    position: viewModeToDefaultCameraPosition[viewMode],
    target: [0, 0, 0],
    up: viewModeToDefaultCameraUp[viewMode],
    fov: 20,
    orthoScale: 0.5
  };
};
export var getDefaultViewerChannelSettings = function getDefaultViewerChannelSettings() {
  return {
    groups: [{
      name: "Channels",
      channels: [{
        match: [0, 1, 2],
        enabled: true
      }, {
        match: "(.+)",
        enabled: false
      }]
    }]
  };
};

/**
 * Returns the default viewer state as a new object.
 */
export var getDefaultViewerState = function getDefaultViewerState() {
  return {
    viewMode: ViewMode.threeD,
    // "XY", "XZ", "YZ"
    renderMode: RenderMode.volumetric,
    // "pathtrace", "maxproject"
    imageType: ImageType.segmentedCell,
    showAxes: false,
    showBoundingBox: false,
    backgroundColor: BACKGROUND_COLOR_DEFAULT,
    boundingBoxColor: BOUNDING_BOX_COLOR_DEFAULT,
    autorotate: false,
    maskAlpha: ALPHA_MASK_SLIDER_DEFAULT,
    brightness: BRIGHTNESS_SLIDER_LEVEL_DEFAULT,
    density: DENSITY_SLIDER_LEVEL_DEFAULT,
    levels: LEVELS_SLIDER_DEFAULT,
    interpolationEnabled: INTERPOLATION_ENABLED_DEFAULT,
    region: {
      x: [0, 1],
      y: [0, 1],
      z: [0, 1]
    },
    slice: {
      x: 0.5,
      y: 0.5,
      z: 0.5
    },
    time: 0,
    // Do not override camera position, target, etc. by default;
    // instead, let the viewer apply default camera settings based on the view mode.
    // This prevents a bug where the camera's position and view mode are set to
    // incompatible states and the viewport becomes blank.
    cameraState: USE_VIEW_MODE_DEFAULT_CAMERA
  };
};
var INIT_COLORS = PRESET_COLORS_0;

/** Returns the default color for a channel, by its index. */
export function getDefaultChannelColor(channelIndex) {
  return INIT_COLORS[channelIndex % INIT_COLORS.length];
}

/**
 * Returns the default channel state as a new object. If an index is provided, uses the default
 * color preset for that index.
 * @param index Optional channel index to use for the color preset.
 * @returns a default ChannelState object.
 */
export var getDefaultChannelState = function getDefaultChannelState() {
  var index = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : 0;
  return {
    name: "",
    displayName: "",
    volumeEnabled: false,
    isosurfaceEnabled: false,
    colorizeEnabled: false,
    colorizeAlpha: 1.0,
    isovalue: 128,
    opacity: 1.0,
    color: getDefaultChannelColor(index),
    useControlPoints: false,
    ramp: [0, TFEDITOR_MAX_BIN],
    controlPoints: [{
      x: 0,
      opacity: 0,
      color: [255, 255, 255]
    }, {
      x: 255,
      opacity: 1,
      color: [255, 255, 255]
    }]
  };
};