function _typeof(o) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (o) { return typeof o; } : function (o) { return o && "function" == typeof Symbol && o.constructor === Symbol && o !== Symbol.prototype ? "symbol" : typeof o; }, _typeof(o); }
function _classCallCheck(a, n) { if (!(a instanceof n)) throw new TypeError("Cannot call a class as a function"); }
function _defineProperties(e, r) { for (var t = 0; t < r.length; t++) { var o = r[t]; o.enumerable = o.enumerable || !1, o.configurable = !0, "value" in o && (o.writable = !0), Object.defineProperty(e, _toPropertyKey(o.key), o); } }
function _createClass(e, r, t) { return r && _defineProperties(e.prototype, r), t && _defineProperties(e, t), Object.defineProperty(e, "prototype", { writable: !1 }), e; }
function _defineProperty(e, r, t) { return (r = _toPropertyKey(r)) in e ? Object.defineProperty(e, r, { value: t, enumerable: !0, configurable: !0, writable: !0 }) : e[r] = t, e; }
function _toPropertyKey(t) { var i = _toPrimitive(t, "string"); return "symbol" == _typeof(i) ? i : i + ""; }
function _toPrimitive(t, r) { if ("object" != _typeof(t) || !t) return t; var e = t[Symbol.toPrimitive]; if (void 0 !== e) { var i = e.call(t, r || "default"); if ("object" != _typeof(i)) return i; throw new TypeError("@@toPrimitive must return a primitive value."); } return ("string" === r ? String : Number)(t); }
var PLAY_STEP_INTERVAL_MS = 125;
var PlayControls = /*#__PURE__*/function () {
  function PlayControls() {
    _classCallCheck(this, PlayControls);
    _defineProperty(this, "playingAxis", null);
    _defineProperty(this, "playWaitingForLoad", false);
    _defineProperty(this, "playHolding", false);
    _defineProperty(this, "playTimeoutId", 0);
  }
  return _createClass(PlayControls, [{
    key: "setPlayingAxis",
    value: function setPlayingAxis(axis) {
      var _this$onPlayingAxisCh;
      this.playingAxis = axis;
      (_this$onPlayingAxisCh = this.onPlayingAxisChanged) === null || _this$onPlayingAxisCh === void 0 || _this$onPlayingAxisCh.call(this, axis);
    }
  }, {
    key: "playStep",
    value: function playStep() {
      var _this$getVolumeIsLoad;
      if (!this.playingAxis || this.playHolding || !this.stepAxis) {
        return;
      }
      // If the volume is not loaded, wait for it to load before continuing
      if (!((_this$getVolumeIsLoad = this.getVolumeIsLoaded) !== null && _this$getVolumeIsLoad !== void 0 && _this$getVolumeIsLoad.call(this))) {
        this.playWaitingForLoad = true;
        return;
      }
      this.stepAxis(this.playingAxis);
      this.playTimeoutId = window.setTimeout(this.playStep.bind(this), PLAY_STEP_INTERVAL_MS);
    }

    /** Call whenever new data is loaded to resume playback if it was paused for data loading. */
  }, {
    key: "onImageLoaded",
    value: function onImageLoaded() {
      if (this.playWaitingForLoad) {
        this.playWaitingForLoad = false;
        this.playStep();
      }
    }

    /**
     * Pause playback on the currently playing axis.
     * `willResume` marks this as a temporary suspension, e.g. while the user is scrubbing along the playing axis.
     */
  }, {
    key: "pause",
    value: function pause() {
      var willResume = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : false;
      window.clearTimeout(this.playTimeoutId);
      this.playTimeoutId = 0;
      this.playWaitingForLoad = false;
      if (this.playingAxis !== null && !willResume) {
        this.playHolding = false;
        this.setPlayingAxis(null);
      }
    }

    /** Begin playback on `axis`. */
  }, {
    key: "play",
    value: function play(axis) {
      if (this.playingAxis !== null) {
        this.pause(true);
      }
      this.setPlayingAxis(axis);
      this.playStep();
    }

    /** If `axis` is currently playing, begin a temporary hold on playback while other input is pending. */
  }, {
    key: "startHold",
    value: function startHold(axis) {
      this.playHolding = true;
      this.pause(axis === this.playingAxis);
    }

    /** If a playback hold is active, end it. */
  }, {
    key: "endHold",
    value: function endHold() {
      if (this.playHolding) {
        this.playHolding = false;
        this.playStep();
      }
    }
  }]);
}();
export { PlayControls as default };