export var gammaSliderToImageValues = function gammaSliderToImageValues(sliderValues) {
  var min = Number(sliderValues[0]);
  var mid = Number(sliderValues[1]);
  var max = Number(sliderValues[2]);
  if (mid > max || mid < min) {
    mid = 0.5 * (min + max);
  }
  var div = 255;
  min /= div;
  max /= div;
  mid /= div;
  var diff = max - min;
  var x = (mid - min) / diff;
  var scale = 4 * x * x;
  if ((mid - 0.5) * (mid - 0.5) < 0.0005) {
    scale = 1.0;
  }
  return {
    min: min,
    max: max,
    scale: scale
  };
};

// Density and brightness are overloaded for the two supported rendering modes in the volume viewer.
// These formulae are somewhat ad-hoc based on what will subjectively look reasonable in the viewer, and should be considered tweakable.
// The volume-viewer expects to see numbers from 0..1 for density, brightness, and alpha.
export var densitySliderToImageValue = function densitySliderToImageValue(sliderValues, _isPT) {
  return +sliderValues / 100.0;
};
export var brightnessSliderToImageValue = function brightnessSliderToImageValue(sliderValues, _isPT) {
  return +sliderValues / 100.0;
};
export var alphaSliderToImageValue = function alphaSliderToImageValue(sliderValues) {
  return 1 - sliderValues / 100.0;
};