function _typeof(o) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (o) { return typeof o; } : function (o) { return o && "function" == typeof Symbol && o.constructor === Symbol && o !== Symbol.prototype ? "symbol" : typeof o; }, _typeof(o); }
function _defineProperty(e, r, t) { return (r = _toPropertyKey(r)) in e ? Object.defineProperty(e, r, { value: t, enumerable: !0, configurable: !0, writable: !0 }) : e[r] = t, e; }
function _toPropertyKey(t) { var i = _toPrimitive(t, "string"); return "symbol" == _typeof(i) ? i : i + ""; }
function _toPrimitive(t, r) { if ("object" != _typeof(t) || !t) return t; var e = t[Symbol.toPrimitive]; if (void 0 !== e) { var i = e.call(t, r || "default"); if ("object" != _typeof(i)) return i; throw new TypeError("@@toPrimitive must return a primitive value."); } return ("string" === r ? String : Number)(t); }
function _createForOfIteratorHelper(r, e) { var t = "undefined" != typeof Symbol && r[Symbol.iterator] || r["@@iterator"]; if (!t) { if (Array.isArray(r) || (t = _unsupportedIterableToArray(r)) || e && r && "number" == typeof r.length) { t && (r = t); var _n = 0, F = function F() {}; return { s: F, n: function n() { return _n >= r.length ? { done: !0 } : { done: !1, value: r[_n++] }; }, e: function e(r) { throw r; }, f: F }; } throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); } var o, a = !0, u = !1; return { s: function s() { t = t.call(r); }, n: function n() { var r = t.next(); return a = r.done, r; }, e: function e(r) { u = !0, o = r; }, f: function f() { try { a || null == t["return"] || t["return"](); } finally { if (u) throw o; } } }; }
function _unsupportedIterableToArray(r, a) { if (r) { if ("string" == typeof r) return _arrayLikeToArray(r, a); var t = {}.toString.call(r).slice(8, -1); return "Object" === t && r.constructor && (t = r.constructor.name), "Map" === t || "Set" === t ? Array.from(r) : "Arguments" === t || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(t) ? _arrayLikeToArray(r, a) : void 0; } }
function _arrayLikeToArray(r, a) { (null == a || a > r.length) && (a = r.length); for (var e = 0, n = Array(a); e < a; e++) n[e] = r[e]; return n; }
import { OTHER_CHANNEL_KEY, SINGLE_GROUP_CHANNEL_KEY } from "../constants";

/** Settings for a single channel, as passed in via props by App users */

export function matchChannel(channelName, channelIndex, c) {
  // c could be a number, an array of (strings or numbers), or a single regex
  if (typeof c.match === "number") {
    if (c.match === channelIndex) {
      return true;
    }
  } else if (Array.isArray(c.match)) {
    var _iterator = _createForOfIteratorHelper(c.match),
      _step;
    try {
      for (_iterator.s(); !(_step = _iterator.n()).done;) {
        var r = _step.value;
        if (typeof r === "number") {
          if (r === channelIndex) {
            return true;
          }
        } else {
          var re = new RegExp(r);
          if (re.test(channelName)) {
            return true;
          }
        }
      }
    } catch (err) {
      _iterator.e(err);
    } finally {
      _iterator.f();
    }
  } else if (typeof c.match === "string") {
    var _re = new RegExp(c.match);
    if (_re.test(channelName)) {
      return true;
    }
  } else {
    throw new Error("match is required for channel settings groups, and must be a string, number, or array of strings or numbers");
  }
  return false;
}
function findFirstChannelMatchOfGroup(channel, channelIndex, g) {
  var _iterator2 = _createForOfIteratorHelper(g.channels),
    _step2;
  try {
    for (_iterator2.s(); !(_step2 = _iterator2.n()).done;) {
      var c = _step2.value;
      if (matchChannel(channel, channelIndex, c)) {
        return c;
      }
    }
  } catch (err) {
    _iterator2.e(err);
  } finally {
    _iterator2.f();
  }
  return undefined;
}
export function findFirstChannelMatch(channel, channelIndex, settings) {
  if (!settings.groups) {
    return undefined;
  }
  var _iterator3 = _createForOfIteratorHelper(settings.groups),
    _step3;
  try {
    for (_iterator3.s(); !(_step3 = _iterator3.n()).done;) {
      var g = _step3.value;
      var c = findFirstChannelMatchOfGroup(channel, channelIndex, g);
      if (c !== undefined) {
        return c;
      }
    }
  } catch (err) {
    _iterator3.e(err);
  } finally {
    _iterator3.f();
  }
  return undefined;
}
export function getDisplayName(name, index, settings) {
  if (settings) {
    var c = findFirstChannelMatch(name, index, settings);
    if (c) {
      return c.name || name;
    }
  }
  return name;
}
export function makeChannelIndexGrouping(channels, settings) {
  if (!channels) {
    return {};
  }
  if (!settings) {
    // return all channels
    return _defineProperty({}, SINGLE_GROUP_CHANNEL_KEY, channels.map(function (_val, index) {
      return index;
    }));
  }
  var groups = settings.groups;
  var grouping = {};
  var channelsMatched = [];
  // this is kinda inefficient but we want to ensure the order as specified in viewerChannelSettings
  if (groups !== undefined) {
    var _iterator4 = _createForOfIteratorHelper(groups),
      _step4;
    try {
      var _loop = function _loop() {
        var g = _step4.value;
        grouping[g.name] = [];
        g.channels.forEach(function (groupMatch) {
          // check all channels against the match
          channels.forEach(function (channel, index) {
            // make sure channel was not already matched someplace.
            if (!channelsMatched.includes(index)) {
              if (matchChannel(channel, index, groupMatch)) {
                grouping[g.name].push(index);
                channelsMatched.push(index);
              }
            }
          });
        });
      };
      for (_iterator4.s(); !(_step4 = _iterator4.n()).done;) {
        _loop();
      }
    } catch (err) {
      _iterator4.e(err);
    } finally {
      _iterator4.f();
    }
  }
  // now any channels not still matched go in the catchall group.
  if (channelsMatched.length < channels.length) {
    var remainderGroupName = groups.length === 0 ? SINGLE_GROUP_CHANNEL_KEY : OTHER_CHANNEL_KEY;
    grouping[remainderGroupName] = [];
    channels.forEach(function (channel, index) {
      // make sure channel was not already matched someplace.
      if (!channelsMatched.includes(index)) {
        grouping[remainderGroupName].push(index);
      }
    });
  }
  return grouping;
}