import React from "react";
import { View3d, Volume } from "@aics/volume-viewer";
import { AxisName, PerAxis } from "../../shared/types";
import { ViewMode } from "../../shared/enums";
import { ViewerSettingUpdater } from "../ViewerStateProvider/types";
import PlayControls from "../../shared/utils/playControls";
import "./styles.css";
interface ViewerWrapperProps {
    view3d: View3d;
    loadingImage: boolean;
    appHeight: string;
    image: Volume | null;
    numSlices: PerAxis<number>;
    numSlicesLoaded: PerAxis<number>;
    playControls: PlayControls;
    playingAxis: AxisName | "t" | null;
    numTimesteps: number;
    visibleControls: {
        axisClipSliders: boolean;
    };
    onClippingPanelVisibleChange?: (panelOpen: boolean, hasTime: boolean) => void;
    onClippingPanelVisibleChangeEnd?: (panelOpen: boolean) => void;
    autorotate: boolean;
    viewMode: ViewMode;
    region: PerAxis<[number, number]>;
    slice: PerAxis<number>;
    time: number;
    changeViewerSetting: ViewerSettingUpdater;
}
declare const _default: React.FC<Omit<ViewerWrapperProps, "viewMode" | "autorotate" | "region" | "slice" | "time" | "changeViewerSetting">>;
export default _default;
