import React from "react";
import { Channel } from "@aics/volume-viewer";
import type { ChannelGrouping, ViewerChannelSettings } from "../shared/utils/viewerChannelSettings";
import type { ColorArray, ColorObject } from "../shared/utils/colorRepresentations";
import type { IsosurfaceFormat } from "../shared/types";
import type { ChannelSettingUpdater, ChannelState } from "./ViewerStateProvider/types";
export type ChannelsWidgetProps = {
    channelDataChannels: Channel[] | undefined;
    channelGroupedByType: ChannelGrouping;
    viewerChannelSettings?: ViewerChannelSettings;
    saveIsosurface: (channelIndex: number, type: IsosurfaceFormat) => void;
    onApplyColorPresets: (presets: ColorArray[]) => void;
    filterFunc?: (key: string) => boolean;
    onColorChangeComplete?: (newRGB: ColorObject, oldRGB?: ColorObject, index?: number) => void;
    channelSettings: ChannelState[];
    changeChannelSetting: ChannelSettingUpdater;
};
declare const _default: React.FC<Omit<ChannelsWidgetProps, "channelSettings" | "changeChannelSetting">>;
export default _default;
