import React from "react";
import ChannelsWidget from "../ChannelsWidget";
import GlobalVolumeControls, { GlobalVolumeControlsProps } from "../GlobalVolumeControls";
import CustomizeWidget, { CustomizeWidgetProps } from "../CustomizeWidget";
import "./styles.css";
import { MetadataRecord } from "../../shared/types";
type PropsOf<T> = T extends React.ComponentType<infer P> ? P : never;
interface ControlPanelProps extends PropsOf<typeof ChannelsWidget>, PropsOf<typeof GlobalVolumeControls>, PropsOf<typeof CustomizeWidget> {
    hasImage: boolean;
    visibleControls: GlobalVolumeControlsProps["visibleControls"] & CustomizeWidgetProps["visibleControls"] & {
        colorPresetsDropdown: boolean;
        metadataViewer: boolean;
    };
    getMetadata: () => MetadataRecord;
    collapsed: boolean;
    setCollapsed: (value: boolean) => void;
    resetToDefaultViewerState: () => void;
}
declare const _default: React.FC<Omit<ControlPanelProps, "resetToDefaultViewerState">>;
export default _default;
