import React from "react";
import { ViewerSettingUpdater } from "./ViewerStateProvider/types";
export interface GlobalVolumeControlsProps {
    imageName: string | undefined;
    pixelSize: [number, number, number];
    visibleControls: {
        alphaMaskSlider: boolean;
        brightnessSlider: boolean;
        densitySlider: boolean;
        levelsSliders: boolean;
        interpolationControl: boolean;
    };
    maskAlpha: number;
    brightness: number;
    density: number;
    levels: [number, number, number];
    interpolationEnabled: boolean;
    changeViewerSetting: ViewerSettingUpdater;
}
declare const _default: React.FC<Omit<GlobalVolumeControlsProps, "maskAlpha" | "brightness" | "density" | "levels" | "interpolationEnabled" | "changeViewerSetting">>;
export default _default;
