import React from "react";
import { ViewerSettingUpdater } from "../ViewerStateProvider/types";
import { ImageType, RenderMode, ViewMode } from "../../shared/enums";
import "./styles.css";
interface ToolbarProps {
    cellDownloadHref: string;
    fovDownloadHref: string;
    hasCellId: boolean;
    hasParentImage: boolean;
    canPathTrace: boolean;
    resetCamera: () => void;
    downloadScreenshot: () => void;
    visibleControls: {
        autoRotateButton: boolean;
        viewModeRadioButtons: boolean;
        fovCellSwitchControls: boolean;
        resetCameraButton: boolean;
        showAxesButton: boolean;
        showBoundingBoxButton: boolean;
    };
    imageType: ImageType;
    renderMode: RenderMode;
    viewMode: ViewMode;
    autorotate: boolean;
    showAxes: boolean;
    showBoundingBox: boolean;
    changeViewerSetting: ViewerSettingUpdater;
    resetToSavedViewerState: () => void;
}
declare const _default: React.FC<Omit<ToolbarProps, "viewMode" | "renderMode" | "imageType" | "showAxes" | "showBoundingBox" | "autorotate" | "changeViewerSetting" | "resetToSavedViewerState">>;
export default _default;
