import React from "react";
import "./styles.css";
interface NumericInputProps {
    value: number;
    step?: number;
    precision?: number;
    min?: number;
    max?: number;
    disabled?: boolean;
    className?: string;
    onChange: (value: number) => void;
}
/**
 * Fully-controlled numeric input (value must be supplied from state in parent).
 * Changeable with arrow keys, typing values, or clickable arrows. Inspired by
 * ant's `InputNumber`, but conforms to our style and behavior expectations.
 */
declare const NumericInput: React.FC<NumericInputProps>;
export default NumericInput;
