import React from "react";
import { CheckboxChangeEvent } from "antd/lib/checkbox";
type SharedCheckboxProps<T> = React.PropsWithChildren<{
    allOptions: T[];
    checkedList: T[];
    onChecked: (checked: T[]) => void;
    onUnchecked: (unchecked: T[]) => void;
    style?: React.CSSProperties;
}>;
type SharedCheckboxState<T> = {
    checkedList: T[];
    indeterminate: boolean;
    checkAll: boolean;
};
export default class SharedCheckbox<T> extends React.Component<SharedCheckboxProps<T>, SharedCheckboxState<T>> {
    constructor(props: SharedCheckboxProps<T>);
    static getDerivedStateFromProps<T>(newProps: SharedCheckboxProps<any>): Partial<SharedCheckboxState<T>>;
    onCheckAllChange({ target }: CheckboxChangeEvent): void;
    render(): React.ReactNode;
}
export {};
