import { AxisName } from "../types";
type PlayAxisName = AxisName | "t";
export default class PlayControls {
    playingAxis: PlayAxisName | null;
    playWaitingForLoad: boolean;
    playHolding: boolean;
    playTimeoutId: number;
    getVolumeIsLoaded?: () => boolean;
    stepAxis?: (axis: PlayAxisName) => void;
    onPlayingAxisChanged?: (axis: PlayAxisName | null) => void;
    private setPlayingAxis;
    private playStep;
    /** Call whenever new data is loaded to resume playback if it was paused for data loading. */
    onImageLoaded(): void;
    /**
     * Pause playback on the currently playing axis.
     * `willResume` marks this as a temporary suspension, e.g. while the user is scrubbing along the playing axis.
     */
    pause(willResume?: boolean): void;
    /** Begin playback on `axis`. */
    play(axis: PlayAxisName): void;
    /** If `axis` is currently playing, begin a temporary hold on playback while other input is pending. */
    startHold(axis: PlayAxisName): void;
    /** If a playback hold is active, end it. */
    endHold(): void;
}
export {};
