import { ChannelState, ViewerSettingUpdater, ViewerState } from "../../components/ViewerStateProvider/types";
import { ColorArray } from "./colorRepresentations";
import { ViewerChannelSettings } from "./viewerChannelSettings";
/** Sets all fields of the viewer state to the values of the `newState`. */
export declare function overrideViewerState(changeViewerSetting: ViewerSettingUpdater, newState: ViewerState): void;
export declare function overrideChannelStates(setChannelSettings: (settings: ChannelState[]) => void, currentStates: ChannelState[], newStates: ChannelState[]): void;
/** Returns the indices of channels that have either the volume or isosurface enabled. */
export declare function getEnabledChannelIndices(channelSettings: ChannelState[]): number[];
export declare function colorHexToArray(hex: string): ColorArray | null;
export declare function initializeOneChannelSetting(channelName: string, index: number, defaultColor: ColorArray, viewerChannelSettings?: ViewerChannelSettings, defaultChannelState?: ChannelState): ChannelState;
